function LevelSetup()

	-- Set Global Values
	Globals.G.Asteroids=(0)
	Globals.Asteroids.MinSendDistance=0.5
	Globals.Asteroids.MaxSendDistance=0.5
	Globals.G.EnemyFactionsMin=(1)
	Globals.G.EnemyFactionsMax=(1)
	Globals.Mines.GrowTime=(30)
	Globals.Structures.FlowerProbability=(0.05)
	Globals.Asteroids.MinCoreHealth=99
	Globals.Asteroids.MaxCoreHealth=799
	Globals.Asteroids.SpawnCap=55
	Globals.Asteroids.SeedlingCap=3000
	
	--Globals.Structures.MinHealth=200
	--Globals.Structures.MaxHealth=400

	--Globals.Mines.MinSpeed=1200
	--Globals.Mines.MaxSpeed=1200
	--Globals.Mines.MinHealth=2000
	--Globals.Mines.MaxHealth=2000

	-- Grey's AI
	GetAI(0).Cowardice = 0.06 	
	GetAI(0).MinExpansionForce = 10
	GetAI(0).BattleSavvy = 0.4 	
	GetAI(0).ReinforcementGreed = 0.3 
	GetAI(0).GreedyExpansion = 0.6 	
	GetAI(0).AidEnthusiasm = 0.2 	
	GetAI(0).ExpandBlind = 0.3 	
	GetAI(0).ExpandToValuableAsteroidChance = 0.5 


SetBackdropColour(180,222,170)


--

	--   central big - starting roid

	a = AddAsteroidWithAttribs(500,0, 0.93,0.95,0.81)
	a.Owner = 1
	a.TreeCap = 6
	a:SetRadius(750)
	a.SendDistance = 4500
	a.Moveable = False
	a:AddSeedlings(200)
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDysonTree()
	f = s:AddFlower()
	
	

--

	-- south west 1 closest to centre
	a = AddAsteroidWithAttribs(-1300,650, 0.78,0.67,0.65)
	a.Owner = 1
	a.TreeCap = 3
	a:SetRadius(160)
	a.SendDistance = 1800
	s = a:AddDefenseTree()
	s:LevelUp()
	a.Moveable = False

	-- south west 2 
	a = AddAsteroidWithAttribs(-2750,1450, 0.78,0.75,0.8)
	a.Owner = 0
	a.TreeCap = 3
	a:SetRadius(200)
	a.SendDistance = 1800
	s = a:AddDefenseTree()
	s:LevelUp()
	a.Moveable = False

	-- south west 3 western most
	a = AddAsteroidWithAttribs(-6300,200, 0.58,0.60,0.65)
	a.Owner = 0
	a.TreeCap = 5
	a:SetRadius(470)
	a.SendDistance = 5500
	a.Moveable = False
	s = a:AddDefenseTree()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	a:AddSeedlings(20)
	
	-- south west 4 
	a = AddAsteroidWithAttribs(-1400,3300, 0.58,0.60,0.65)
	a.Owner = 2
	a.TreeCap = 5
	a:SetRadius(355)
	a.SendDistance = 3000
	a.Moveable = False
	s = a:AddDefenseTree()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	f = s:AddFlower()
	a:AddSeedlings(50)
	
	-- south west 5
	a = AddAsteroidWithAttribs(-800,5300, 0.55,0.60,0.75)
	a.Owner = 0
	a.TreeCap = 4
	a:SetRadius(275)
	a.SendDistance = 3000
	a.Moveable = False
	s = a:AddDysonTree()	
	a:AddSeedlings(15)

	

	
--
	-- south east 1 - old starting roid. changed to centre
	a = AddAsteroidWithAttribs(900,7000, 0.71,0.49,0.57)
	a.Owner = 2
	a.TreeCap = 4
	a:SetRadius(200)
	a.SendDistance = 2700
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()	
	s:LevelUp()
	f = s:AddFlower()
	a.Moveable = False
	a:AddSeedlings(55)

	-- south east 2 
	a = AddAsteroidWithAttribs(1600,9900, 0.91,0.88,0.68)
	a.Owner = 0
	a.TreeCap = 3
	a:SetRadius(150)
	a.SendDistance = 4200
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()	
	a.Moveable = False
	

	-- south east 3 southern most roid
	a = AddAsteroidWithAttribs(2600,18000, 0.91,0.95,0.5)
	a.Owner = 0
	a.TreeCap = 3
	a:SetRadius(150)
	a.SendDistance = 15000
	a.Moveable = False
	a:AddSeedlings(5)
	

	-- south east 4
	a = AddAsteroidWithAttribs(1550,4100, 0.55,0.81,0.79)
	a.Owner = 0
	a.TreeCap = 3
	a:SetRadius(205)
	a.SendDistance = 3200
	a.Moveable = False
	s = a:AddDefenseTree()
	s = a:AddDysonTree()	
	a:AddSeedlings(10)

	-- south east 5
	a = AddAsteroidWithAttribs(2750,2200, 0.7,0.71,0.69)
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(230)
	a.SendDistance = 3100
	a.Moveable = False
	s = a:AddDefenseTree()
	s = a:AddDysonTree()	
	a:AddSeedlings(10)

	-- south east 6 
	a = AddAsteroidWithAttribs(6000,1900, 0.74,0.73,0.89)
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(190)
	a.SendDistance = 4500
	a.Moveable = False
	s = a:AddDefenseTree()
	s = a:AddDysonTree()	
	a:AddSeedlings(10)

	-- south east 7 eastern most
	a = AddAsteroidWithAttribs(9000,4000, 0.94,0.79,0.92)
	a.Owner = 2
	a.TreeCap = 5
	a:SetRadius(695)
	a.SendDistance = 7900
	a.Moveable = False
	s = a:AddDefenseTree()
	s = a:AddDysonTree()	
	a:AddSeedlings(10)
	
		
-- central planets between 'big ones'

	-- north east 1 first closest east roid
	a = AddAsteroidWithAttribs(1400,-2800, 0.71,0.49,0.57)
	a.Owner = 0
	a.TreeCap = 4
	a:SetRadius(225)
	a.SendDistance = 2500
	s = a:AddDefenseTree()
	s:LevelUp()
	a.Moveable = False
	a:AddSeedlings(5)

	-- north east 2
	a = AddAsteroidWithAttribs(1600,-4100, 0.81,0.69,0.83)
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(180)
	a.SendDistance = 2500
	s = a:AddDefenseTree()
	a.Moveable = False
	a:AddSeedlings(10)

	-- north east 3
	a = AddAsteroidWithAttribs(1300,-7000, 0.83,0.79,0.73)
	a.Owner = 2
	a.TreeCap = 4
	a:SetRadius(285)
	a.SendDistance = 3000
	s = a:AddDefenseTree()
	s:LevelUp()
	a.Moveable = False
	a:AddSeedlings(10)

	-- north east 4
	a = AddAsteroidWithAttribs(3300,-2600, 0.81,0.80,0.78)
	a.Owner = 2
	a.TreeCap = 4
	a:SetRadius(260)
	a.SendDistance = 2900
	s = a:AddDysonTree()
	a.Moveable = False
	a:AddSeedlings(10)

	-- north east 5 
	a = AddAsteroidWithAttribs(5000,-6300, 0.79,0.88,0.85)
	a.Owner = 2
	a.TreeCap = 4
	a:SetRadius(395)
	a.SendDistance = 4500
	s = a:AddDefenseTree()
	a.Moveable = False
	a:AddSeedlings(25)

	-- north east 6
	a = AddAsteroidWithAttribs(3600,-300, 0.7,0.79,0.83)
	a.Owner = 0
	a.TreeCap = 3
	a:SetRadius(150)
	a.SendDistance = 2700
	s = a:AddDefenseTree()
	a.Moveable = False

	-- north east 7 
	a = AddAsteroidWithAttribs(5400,-4500, 0.65,0.69,0.9)
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(185)
	a.SendDistance = 2800
	s = a:AddDefenseTree()
	a.Moveable = False
	a:AddSeedlings(25)

	-- north east 8
	a = AddAsteroidWithAttribs(3950,-1450, 0.8,0.79,0.83)
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(110)
	a.SendDistance = 1000
	s = a:AddDefenseTree()
	a.Moveable = False

	-- north east 9
	a = AddAsteroidWithAttribs(5200,-2100, 0.9,0.69,0.85)
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(140)
	a.SendDistance = 1800
	s = a:AddDefenseTree()
	a.Moveable = False
	

	-- north east 10
	a = AddAsteroidWithAttribs(6500,-2700, 0.79,0.81,0.75)
	a.Owner = 2
	a.TreeCap = 4
	a:SetRadius(150)
	a.SendDistance = 1800
	s = a:AddDefenseTree()
	a.Moveable = False

	-- north east 11 
	a = AddAsteroidWithAttribs(7700,-4800, 0.85,0.88,0.89)
	a.Owner = 2
	a.TreeCap = 5
	a:SetRadius(455)
	a.SendDistance = 6500
	s = a:AddDefenseTree()
	a.Moveable = False
	a:AddSeedlings(15)
	
	-- north east 12 
	a = AddAsteroidWithAttribs(9100,-8000, 0.68,0.65,0.78)
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(185)
	a.SendDistance = 4000
	s = a:AddDysonTree()
	a.Moveable = False
	a:AddSeedlings(10)

	-- north east 13 north and eastern most
	a = AddAsteroidWithAttribs(13000,-10500, 0.98,0.95,0.98)
	a.Owner = 2
	a.TreeCap = 6
	a:SetRadius(985)
	a.SendDistance = 12000
	s = a:AddDysonTree()
	a.Moveable = False
	a:AddSeedlings(30)

	


--
	-- north west 1
	a = AddAsteroidWithAttribs(-1650,-3200, 0.58,0.62,0.65)
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(125)
	a.SendDistance = 4500
	s = a:AddDefenseTree()
	s:LevelUp()
	a.Moveable = False

	-- north west 2 closest west roid
	a = AddAsteroidWithAttribs(-95,-4650, 0.69,0.82,0.77)
	a.Owner = 2
	a.TreeCap = 4
	a:SetRadius(200)
	a.SendDistance = 3600
	s = a:AddDefenseTree()
	s:LevelUp()
	a.Moveable = False
	a:AddSeedlings(25)

	-- north west 3
	a = AddAsteroidWithAttribs(-2275,-6100, 0.61,0.89,0.79)
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(300)
	a.SendDistance = 3500
	s = a:AddDysonTree()
	a.Moveable = False
	a:AddSeedlings(10)

	-- north west 4 
	a = AddAsteroidWithAttribs(-6350,-8650, 0.86,0.89,0.9)
	a.Owner = 2
	a.TreeCap = 5
	a:SetRadius(500)
	a.SendDistance = 4500
	s = a:AddDysonTree()
	a.Moveable = False
	a:AddSeedlings(10)

	-- north west 5
	a = AddAsteroidWithAttribs(-6450,-6000, 0.78,0.85,0.8)
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(180)
	a.SendDistance = 4000
	s = a:AddDysonTree()
	a.Moveable = False
	a:AddSeedlings(10)

	-- north west 6
	a = AddAsteroidWithAttribs(-4900,-6700, 0.68,0.85,0.79)
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(155)
	a.SendDistance = 4000
	s = a:AddDysonTree()
	a.Moveable = False
	a:AddSeedlings(10)

	-- north west 7 
	a = AddAsteroidWithAttribs(-5000,-11250, 0.62,0.72,0.75)
	a.Owner = 2
	a.TreeCap = 4
	a:SetRadius(310)
	a.SendDistance = 5000
	s = a:AddDysonTree()
	a.Moveable = False
	a:AddSeedlings(10)

	-- north west 8 north-western most
	a = AddAsteroidWithAttribs(-6900,-12500, 0.68,0.95,0.88)
	a.Owner = 2
	a.TreeCap = 4
	a:SetRadius(405)
	a.SendDistance = 6000
	s = a:AddDysonTree()
	a.Moveable = False
	a:AddSeedlings(10)

	-- north west 9
	a = AddAsteroidWithAttribs(-2150,-2000, 0.51,0.9,0.85)
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(250)
	a.SendDistance = 2500
	s = a:AddDysonTree()
	s = a:AddDefenseTree()
	a:AddSeedlings(5)

	-- north west 10
	a = AddAsteroidWithAttribs(-5250,-3900, 0.89,0.81,0.75)
	a.Owner = 2
	a.TreeCap = 4
	a:SetRadius(475)
	a.SendDistance = 4000
	s = a:AddDysonTree()
	s = a:AddDefenseTree()
	a:AddSeedlings(15)

	-- north west 11 
	a = AddAsteroidWithAttribs(-3100,-13100, 0.79,0.69,0.79)
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(180)
	a.SendDistance = 4500
	s = a:AddDysonTree()
	a.Moveable = False
	a:AddSeedlings(10)

	-- north west 12  northern most
	a = AddAsteroidWithAttribs(-1000,-15800, 0.79,0.99,0.9)
	a.Owner = 2
	a.TreeCap = 2
	a:SetRadius(120)
	a.SendDistance = 9500
	s = a:AddDysonTree()
	a.Moveable = False
	a:AddSeedlings(10)

	-- north west 13 
	a = AddAsteroidWithAttribs(-9900,-1800, 0.68,0.89,0.9)
	a.Owner = 2
	a.TreeCap = 5
	a:SetRadius(670)
	a.SendDistance = 7500
	a.Moveable = False
	s = a:AddDefenseTree()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	a:AddSeedlings(25)

	-- north west 14 
	a = AddAsteroidWithAttribs(-13500,-3800, 0.78,0.69,0.79)
	a.Owner = 2
	a.TreeCap = 4
	a:SetRadius(250)
	a.SendDistance = 7500
	a.Moveable = False
	s = a:AddDefenseTree()
	s = a:AddDysonTree()
	a:AddSeedlings(20)

	-- north west 15
	a = AddAsteroidWithAttribs(-500,-8000, 0.73,0.71,0.73)
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(185)
	a.SendDistance = 3000
	s = a:AddDefenseTree()
	s:LevelUp()
	a.Moveable = False
	a:AddSeedlings(10)

	-- north west 16
	a = AddAsteroidWithAttribs(-2900,-9500, 0.77,0.77,0.7)
	a.Owner = 2
	a.TreeCap = 3
	a:SetRadius(175)
	a.SendDistance = 3000
	s = a:AddDefenseTree()
	s:LevelUp()
	a.Moveable = False
	a:AddSeedlings(10)

end


function LevelLogic()

-- Greeting

--
	Timer = GetGameTime() + 14


	while GetGameTime() < Timer do

		coroutine.yield()
	end

	Pause()
	MessageBox(" The threat is all around us...")
	WaitDialog()
	Unpause()
	
	Pause()
	MessageBox("They must be defeated.                                                                                  	I'm trusting you...")
	WaitDialog()
	Unpause()






--colour wave/ pulsing effect
	
	while GameRunning() do

	--rtime = GetGameTime()	 -- setting the variable 'time' to whatever the game time is
	--rtime = rtime / 260 	 -- taking that 'time' variable and dividing it by n.  divide slows down. multiply speeds up.
	gtime = GetGameTime()
	gtime = gtime / 225
	btime = GetGameTime()
	btime = btime / 250

	
	gcolour = math.sin(gtime) -- setting the variable 'rcolour' to wave up and down. like this the range is now -1 to 1. 1 being the peak of the wave and -1 being the trough. with the horizontal axis as 'time', in this case the 'time' variable.

	gcolour = gcolour * gcolour  -- square rcolour, if it is negative this will make it positive
	gcolour = math.sqrt(gcolour) -- now take the square root of it

   	gcolour = gcolour * 70  -- setting the range of 'rcolour' from 0 to 255. in this case the 'r' referring to 'red', multiplied by n. do the same with 'g' and 'b'
	
	gcolour = math.sin(gtime) -- speed of variance
	gcolour = gcolour * 25

--
	bcolour = math.sin(btime) 
	bcolour = bcolour * bcolour  
	bcolour = math.sqrt(bcolour) 

   	bcolour = bcolour * 55 


	bcolour = math.sin(btime)
	bcolour = bcolour * 16


	SetBackdropColour(15,gcolour,bcolour) -- makes the background change between colours. 0 is black/min. 255 is white/max


-- Victory Trigger
			

		if GetEmpire(2):GetNumOwnedAsteroids() == 0 then 
		Pause()
		MessageBox("They are beaten...  Peace at last.                                                  Medals all round and tea and biscuits! ...Now where's that peace chalice...")
		WaitDialog()
		Unpause()
		Quit(true)
		end
		
		

		if GetEmpire(1):GetNumOwnedAsteroids() == 0 then
		Pause()
		MessageBox("Hmm...!                                                                      ...You can do better than that.                                                                         Try again?")
		WaitDialog()
		Unpause()
		Quit(false)
		end

	coroutine.yield()
	end


-- AI

	
	
	GetAsteroid(0):ChangeOwner(2)

	purgetimer = GetGameTime()
	
	while GameRunning() do
	
		
		--AI
	
		checkedroid = GetAI(2):GetRandomAsteroid()
	
		
		if GetGameTime() > purgetimer + 35 then
			purgetimer = 0
		end
		
		
	
		-- First, find out which asteroids are close enough to travel in 1 jump, and 
	
		traversable = {}
		pathsavailable = 0
		
		attackable = {}
		attackpaths = 0

		actiontaken = 0
		
		increasemetricvote = 1
		increasegathermetricvote = 1
		confirmedzero = 0
		confirmedgatherpoint = 0



		if GetEmpire(2):OwnsAsteroidID(checkedroid.ID) then
		
			if checkedroid:GetNumSeedlings(1) == 0 and checkedroid:GetNumSeedlings(2) > 5 then
				for minecheck = 0,roidnumber do
				
					if GetEmpire(2):OwnsAsteroidID(minecheck) == true and GetAsteroid(minecheck):GetNumMines(1) > 0 and checkedroid:GetNumMines(1) == 0 then
						checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),GetAsteroid(minecheck))
					end
				
				end
		
			end
		
			for u = 0,roidnumber do

				if GetAsteroid(u) ~= checkedroid then
					-- only learn about this asteroid if it's not the one being checked
					-- can we send seeds to this roid from the checked one?
					if (GetAsteroid(checkedroid.ID):GetSendDistance() + roidradius[u]) > math.sqrt(((coordx[u] - coordx[checkedroid.ID])^2) + ((coordy[u] - coordy[checkedroid.ID])^2)) then
						-- we can !  Now is this a friendly path or an attackable path?
						if GetEmpire(1):OwnsAsteroidID(u) == true or GetAsteroid(u):GetNumSeedlings(1) > 10 and GetAsteroid(u):GetNumTrees() == 0 then
							attackable[attackpaths] = GetAsteroid(u)
							attackpaths = attackpaths + 1
							
							-- moar aggression ! advantage pressing, etc
							if checkedroid:GetNumSeedlings(2) > 120 and GetAsteroid(u):GetNumSeedlings(1) < (checkedroid:GetNumSeedlings(2) / 2) then
								checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),GetAsteroid(u))
								if rcolour < 105 then
									rcolour = rcolour + 150
								end
							end
						end
					
						if GetAI(2):OwnsAsteroidID(u) == true then

							traversable[pathsavailable] = GetAsteroid(u)
							pathsavailable = pathsavailable + 1
						end
				
					end

					-- ok, this roid is not in range for us.



			
			
			
				end
				-- ok, we were trying to check ourselves.

			
	
	
	
			end
			-- end of neighbour-checking sequence

	
			
		
		

		
		
		
			-- end of metric checking sequence
	
		else
	
			torchlit[checkedroid.ID] = nil
			constructionmetric[checkedroid.ID] = nil
			gathermetric[checkedroid.ID] = nil
	
		end
	
	
		-- we have selected "checkedroid" for checking.  We must find out all we can about the asteroid and it's surroundings, and act appropriately.
		if GetAI(2):OwnsAsteroidID(checkedroid.ID) == true and checkedroid:GetNumMines(1) > 0 then
		
			-- do buggerysquat! (eloquently put)
		

		elseif GetAI(2):OwnsAsteroidID(checkedroid.ID) == true then
			-- this roid is ours ! :>
			
			
			if pathsavailable == 0 then
				-- Orphan Control
				boltfriendly = GetEmpire(2):GetRandomAsteroid()
				letsgo = 0
				
				for iii = 0,attackpaths do
					
					if attackable[iii] ~= nil then
						letsgo = letsgo + (attackable[iii]:GetNumSeedlings(1))
					end
				
				end
				
				if letsgo > checkedroid:GetNumSeedlings(2) and checkedroid:GetNumSeedlings(2) > 10 and checkedroid:GetNumSeedlings(2) < 40 then
				
					checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),boltfriendly)
					
					
				elseif letsgo < checkedroid:GetNumSeedlings(2) and checkedroid:GetNumSeedlings(2) > (40 + (attackable[0]:GetNumDysonTrees() * 5) + (attackable[0]:GetNumDefenseTrees() * 10)) then
				
					checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),attackable[0])
					
					end

				
				elseif attackable[0]:GetNumSeedlings(2) > 5 then
				
					checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),attackable[0])
	
					
				end
				
				
			end
			-- how many player seedlings are here?

			-- more than what we have, and enough to be dangerous.  Also, we do have at least 1 tree here, right?
			if checkedroid:GetNumSeedlings(2) < checkedroid:GetNumSeedlings(1) and checkedroid:GetNumSeedlings(1) > 10 and checkedroid:GetNumTrees() > 0 then
				-- *** WE OWN THIS ASTEROID, THE ENEMY OUTNUMBER US.  WE HAVE AT LEAST ONE TREE HERE.  We are under attack.  torchmetric 0! ***
				torchlit[checkedroid.ID] = 0
				-- ***
			
		--	elseif checkedroid:GetNumSeedlings(2) < checkedroid:GetNumSeedlings(1) and checkedroid:GetNumSeedlings(1) > 10 and checkedroid:GetNumTrees() == 0 then
				-- *** ITS A FALSE ALARM....but dont try to build here unless the player leaves. ***
				--torchlit[checkedroid.ID] = nil
				--constructionmetric[checkedroid.ID] = nil				
				-- but once we get a bit more powerful, we can have a crack at it :>
				
				
			--		if purgetimer == 0 then
			--			purgetimer = GetGameTime() + 30
			--		end
					
			--		if GetGameTime() > purgetimer then
						
						
			--			torchlit[checkedroid.ID] = 0
						
						--for purge = 0,roidnumber do
						--	if GetEmpire(2):OwnsAsteroidID(purge) == true and torchlit[purge] == nil and GetGameTime() > purgetimer + 45 then
						
						--GetAsteroid(purge):SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(1),checkedroid)
						
						
						
						--	end
						
						--	end
						
			--			purgetimer = 0
						
			--		end
				
				-- ***
			end
	
			
			--  more than zero but less than what we have
			if checkedroid:GetNumSeedlings(1) > 0 and checkedroid:GetNumSeedlings(2) > checkedroid:GetNumSeedlings(1) then
				-- *** WE OWN THIS ASTEROID, THERE ARE ENEMIES BUT WE OUTNUMBER THEM.  Not elligible for sending reinforcements to other asteroids, but not in serious danger either. ***
				-- ***
			end
			
			-- No enemies here at all.
			if checkedroid:GetNumSeedlings(1) < 1 then
			
				-- how many of our seedlings are here?
				if checkedroid:GetNumSeedlings(2) > 1 then
					-- 1 or more
		
		
					--how many trees are here?
					if checkedroid:GetNumTrees() < 4 and checkedroid:GetNumSeedlings(2) > 9 then
						-- less than four trees
						-- *** WE OWN THIS ASTEROID, THERE ARE NO ENEMIES HERE.  WE HAVE AT LEAST 10 SEEDLINGS AND LESS THAN 4 TREES.  Plant a tree. ***
						
						
						-- but... is the enemy building up a force nearby, ready to take our freshly built trees..?
						
						danger[checkedroid.ID] = false
						
						for ooo = 0,roidnumber do
							if GetEmpire(1):OwnsAsteroidID(ooo) and GetAsteroid(ooo):GetSendDistance() > math.sqrt(((coordx[ooo] - coordx[checkedroid.ID])^2) + ((coordy[ooo] - coordy[checkedroid.ID])^2)) then
						
								if GetAsteroid(ooo):GetNumSeedlings(1) > 30 then
								
									danger[checkedroid.ID] = true
									dangertimer[checkedroid.ID] = GetGameTime()
								
								end
							
							end
						end
						
						if danger[checkedroid.ID] == true and checkedroid:GetNumSeedlings(2) > 15 then
							
							checkedroid:PlantDysonTree(2)
						
						elseif danger[checkedroid.ID] == false and GetGameTime() > dangertimer[checkedroid.ID] + 25 then
						
							checkedroid:PlantDysonTree(2)
							
						end
						-- ***
					
					
					
					elseif checkedroid:GetNumTrees() == 4 then
						-- four	trees.  ELIGIBLE FOR SENDING REINFORCEMENTS!
						
						if constructionmetric[checkedroid.ID] == 0 then
							-- we just built the last tree.  now we should stop advertising to neighbours that we need more seedlings for construction.
							constructionmetric[checkedroid.ID] = nil
						end
						
						
						-- is my torch metric nil?
						
						if torchlit[checkedroid.ID] ~= nil then
							-- no, my torch metric is not Nil.
							
							-- is my torch metric 0?  Cause, like, I don't have any enemies orbiting me dudez...
							if torchlit[checkedroid.ID] == 0 then
								-- *** ok, so my torch metric is 0 but there are no enemies here.  Switch all torches off....if other roids are under attack they will just switch theirs on again straight away. ***
								-- *** this step is needed to prevent the rest of the torch metrics from spiralling upward out of control.  ***
								for g = 0,roidnumber do
									torchlit[g] = nil
								end									
								-- ***
							else
							
								-- so my torch IS lit, but it's value is NOT zero.  checkedroid is not nil and not 0.
							
								totm = true
							
								for ooo = 0,pathsavailable do
								
									if traversable[ooo] ~= nil then
								
										trav = traversable[ooo]
								
										hopIDint = trav.ID
									
										if torchlit[hopIDint] == 0 and GetGameTime() < 180 then
											
											for emerg = 0,roidnumber do
												if GetEmpire(2):OwnsAsteroidID(emerg) == true then
													GetAsteroid(emerg):SendSeedlingsToTarget(2,GetAsteroid(emerg):GetNumSeedlings(2),traversable[ooo])
												end
											end
										
											totm = false
									
									
										elseif torchlit[hopIDint] == 0 then
											-- *** WE HAVE FOUND A NEIGHBOUR THAT HAS A ROUTE TO AN ASTEROID IN NEED OF DEFENCE.  Send seedlings ***
											
											if GetAsteroid(hopIDint):GetNumSeedlings(1) < 10 then
												checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),traversable[ooo])
												
											elseif GetAsteroid(hopIDint):GetNumSeedlings(2) > GetAsteroid(hopIDint):GetNumSeedlings(1) * 0.6 then
												checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),traversable[ooo])
											
											
											elseif checkedroid:GetNumSeedlings(2) > (GetEmpire(2).NumSeedlings / 20) then
												checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),traversable[ooo])
											end
											
											totm = false
											torchlit[checkedroid.ID] = 1
									
											--				elseif torchlit[checkedroid.ID] == nil then
											
											--					totm = false
											--					torchlit[checkedroid.ID] = torchlit[hopIDint] + 1
											--					shortestpath = hopIDint
											
											
										elseif torchlit[hopIDint] == nil then
										
											-- do nothing, maybe there's no more attack and the metric should be turned off.
											
											
											
											-- my torch metric is already non-nil, so set mine to be his + 1 if he has a shorter path than me.
										elseif torchlit[hopIDint] < torchlit[checkedroid.ID] - 1 then
											totm = false
											torchlit[checkedroid.ID] = torchlit[hopIDint] + 1
											shortestpath = hopIDint
											checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),traversable[ooo])
											
											
										elseif torchlit[hopIDint] == torchlit[checkedroid.ID] - 1 then
										
											totm = false
											torchlit[checkedroid.ID] = torchlit[hopIDint] + 1
											shortestpath = hopIDint
											checkedroid:SendSeedlingsToTarget(2,checkedroid:GetNumSeedlings(2),traversable[ooo])
										
											
									
										end
							
									end
								end
							
							
							
							
							
							
							
								-- *** WE OWN THIS ASTEROID.  THERE ARE NO ENEMIES HERE.  WE HAVE AT LEAST 10 SEEDLINGS AND MAXIMUM TREES.  OUR TORCH METRIC INDICATES ***
								-- *** THAT A NEARBY ASTEROID REQUIRES SEEDLINGS FOR DEFENSE.  Find a neighbour with the lower metric and send 10 seedlings there.  ***
							

							
							end
							
							
						
						elseif torchlit[checkedroid.ID] == nil then
						
							-- yes my torch metric is nil, now lets see if any neighbours have a torch metric of 0..
							
							totm = true
							
							
							
							for ooo = 0,pathsavailable do
								
								if traversable[ooo] ~= nil then
								
									trav = traversable[ooo]
								
									hopIDint = trav.ID
									
									
							
									if torchlit[hopIDint] == 0 then
										-- *** WE HAVE FOUND A NEIGHBOUR THAT NEEDS MORE SEEDS TO DEFEND WITH.  Send 10 seedlings, or more if we have them available. ***
										checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),traversable[ooo])
										totm = false
										torchlit[checkedroid.ID] = 1
										
										
									
									elseif torchlit[hopIDint] ~= nil then
										if torchlit[hopIDint] > 0 then
											-- seedlings needed in this direction!
											
											-- my torch metric is nil at the moment, so set it to his + 1.
											if torchlit[checkedroid.ID] == nil then
												totm = false
												torchlit[checkedroid.ID] = torchlit[hopIDint] + 1
												shortestpath = hopIDint
											end
											
											-- my torch metric is already non-nil, so set mine to be his + 1 if he has a shorter path than me.
											if torchlit[hopIDint] < torchlit[checkedroid.ID] - 1 then
												totm = false
												torchlit[checkedroid.ID] = torchlit[hopIDint] + 1
												shortestpath = hopIDint
											end
											
											
										
										end
										
									
									
									end
							
								end
							end

							-- send seeds along the shortest torch path
							if torchlit[checkedroid.ID] ~= nil then
								if torchlit[checkedroid.ID] > 1 then
								
									checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),GetAsteroid(shortestpath))
								end
							end
							
							if totm == true and torchlit[checkedroid.ID] ~= nil then
								torchlit[checkedroid.ID] = nil
							end
						
						
							-- check if we are still under attack on any asteroids
							stillattacked = false
							
							for o = 0,roidnumber do
								if GetAsteroid(o):GetNumTrees() > 0 and GetAI(2):OwnsAsteroidID(o) and GetAsteroid(o):GetNumSeedlings(1) > 1 then
									stillattacked = true
								end
							end
							
							if stillattacked == false then
								for l = 0,roidnumber do
									torchlit[l] = nil
								end
							end
							
							
							
							-- yes, my torch metric is Nil and so is all my neighbours' - check my construction metric next.
						
							-- turn off construction metric
							tocm = true
							
							for cc = 0,pathsavailable do
								
								if traversable[cc] ~= nil then
								
									trav = traversable[cc]
								
									hopIDint = trav.ID
							
									if constructionmetric[hopIDint] == 0 and danger[checkedroid.ID] == false and GetGameTime() > (dangertimer[checkedroid.ID] + 90) and GetAsteroid(hopIDint):GetNumSeedlings(1) < 8 then
										-- *** WE HAVE FOUND A NEIGHBOUR THAT NEEDS MORE SEEDS TO BUILD WITH.  Send 10 seedlings, or more if we have them available. ***
										checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),traversable[cc])
										tocm = false
										constructionmetric[checkedroid.ID] = 1
									
									
									elseif danger[checkedroid.ID] == true or GetGameTime() < (dangertimer[checkedroid.ID] + 120) then
									
										-- *** WAIT A BIT... THERE'S STILL A BIG FORCE NEARBY ***
										
										tocm = false
										constructionmetric[checkedroid.ID] = 1
									
									
									
									
									elseif constructionmetric[hopIDint] ~= nil then
										if constructionmetric[hopIDint] > 0 then
											-- seedlings needed in this direction!
											
											-- my construction metric is nil at the moment, so set it to his + 1.
											if constructionmetric[checkedroid.ID] == nil then
												tocm = false
												constructionmetric[checkedroid.ID] = constructionmetric[hopIDint] + 1
												shortestpath = hopIDint
											end
											
											-- my construction metric is already non-nil, so set mine to be his + 1 if he has a shorter path than me.
											if constructionmetric[hopIDint] < constructionmetric[checkedroid.ID] - 1 then
												tocm = false
												constructionmetric[checkedroid.ID] = constructionmetric[hopIDint] + 1
												shortestpath = hopIDint
											end
											
											
										
										end
										
									
									
									end
							
								end
							end
						
							-- send seeds along the shortest construction path
							if constructionmetric[checkedroid.ID] ~= nil then
								if constructionmetric[checkedroid.ID] > 1 then
								
									checkedroid:SendSeedlingsToTarget(2,((checkedroid:GetNumSeedlings(2)/pathsavailable) + 10),GetAsteroid(shortestpath))
								end
							end
							
							if tocm == true and constructionmetric[checkedroid.ID] ~= nil then
								constructionmetric[checkedroid.ID] = nil
							end
						
						
							-- check if we are finished building trees on all asteroids
							stillbuilding = false
							
							for o = 0,roidnumber do
								if GetAsteroid(o):GetNumTrees() < 4 and GetAI(2):OwnsAsteroidID(o) then
									stillbuilding = true
								end
							end
							
							if stillbuilding == false then
								for l = 0,roidnumber do
									constructionmetric[l] = nil
								end
							end
						
							
						end
		end			
end					




end
end
end



--

-- a small addendum for those who wish to know a little about my brain activity while building this thing...

-- Hello, this is my 4th map and for this one ive taken the code from mr gravity engine himself, annikk.exe's 'day and night', taken out the auto asteroid generation so i can do them all
-- myself instead, and will be taking snippets from my own map, Aeon, and again, ideas i get from annikk's glorious and superior coding; general praise to you, good sir! EDIT - since starting this
-- i have had to edit some of the code that i can actually follow. a couple of minor time changes, eg, from 25 to 30 seconds, etc. i doubt it will do much but we'll see...

-- i think i like the manual aspect of 'roid creation; it allows the greatest freedom to lay the level out the way you want it. either that or i just have no idea
-- about other code methods :(

-- anyway, i started this map with the intention of making an aesthetically pleasing visual- to be achieved with a combo of light/ colour/ planet size and distances, and of course general layout;
-- then to a slightly lesser degree, seedling flow from one roid to another ( an aspect of the late game in my Aeon map that i personally enjoy watching a great deal - the flow of seedlings from one long distance planet to another).
-- however, this is obviously very important so in no way have i tried to reduce its importance! ;)
-- (i may or may not try using the gravity code, i dont know yet...?) EDIT - this seems doubtful!

-- as of writing this spiel, i have just begun making this thing so i dont even know what it looks like yet in game, but by the end, i have high hopes of
-- it being just a lovely level to play. nothing more. this will take some time i reckon, so, enough rambling and i will 'EDIT' this note after ive 'finished' it 
-- as i progress with more news, for those who're interested.

--EDIT 1 - i have spent 2 days on this, nothing major, but i think ive reached the second and far more enduring half of creating a map- testing and tweaking. the planets are in place (i think!) and so what remains to do now
-- is edit seedling counts, minor distance values, and something ive been thinking a bit about lately, player starting position. in making this map i have had to organise the roids' geography based on the biggest, most central roid, which
-- is not the player's starting roid, so the initial camera view isn't on the player's starting planet. not a big issue for me, but it did get me thinking about some things- starting with more than 1 roid in different parts
-- of a map, or just merely not on 0,0 coords.
--in any case, its coming on nicely. updates when ready...


-- enjoy...

--