function LevelSetup()

--	hallo.  scroll down for the epic coding banter y0.

	SetBackdropColour(0,0,0)

	Globals.Agents.MaxSpeed=600
	Globals.Agents.MinSpeed=130

	Globals.Asteroids.MaxTrees=1
	Globals.Asteroids.MinRadius=300
    Globals.Asteroids.MaxRadius=725
    Globals.Asteroids.RadiusPowerRule=1.5
	Globals.Asteroids.SizeFromEnergy=210
	Globals.Asteroids.SizeFromStrength=210
	Globals.Asteroids.SizeFromSpeed=210
	Globals.Asteroids.MinCoreHealth=500
	Globals.Asteroids.MaxCoreHealth=500
	Globals.Asteroids.CoreHealthPower=3.5
    Globals.Asteroids.MinSendDistance=50
    Globals.Asteroids.MaxSendDistance=10000
	Globals.Asteroids.SpawnCap=150
	Globals.Asteroids.SeedlingCap=500
	
	Globals.Mines.MinHealth=(2500)
	Globals.Mines.MaxHealth=(2500)

	Globals.AI.MinAttackTime=(5)
	Globals.AI.MaxAttackTime=(20)
	Globals.AI.MinGatherTime=(10)
	Globals.AI.MaxGatherTime=(20)
	Globals.AI.MinScoutTime=(1)
	Globals.AI.MaxScoutTime=(5)
	Globals.AI.GraceTimer=(9999)

	Globals.G.Asteroids=(0)
	Globals.G.EnemyFactionsMin=(0)
	Globals.G.EnemyFactionsMax=(0)
	Globals.G.MinAsteroidSeparation=500
	Globals.G.MaxAsteroidNeighbourDist=3500
	Globals.G.StartingSeedlings=(10)
	Globals.G.GreysProbability=0

	Globals.Structures.FlowerProbability=(0.0)

	-- Asteroid 0 - starting asteroid
	a = AddAsteroidWithAttribs(0,0, 0.9,0.9,0.9)
	a.Owner = 1
	a.TreeCap = 0
	a.SpawnCap = 2000
	a.SeedlingCap = 2000
	a:SetRadius(100)
	
	a:AddSuperSeedlings(90)
	a.SendDistance = 2400
	a.Moveable = false

	
	-- Asteroid 1 - first mini zerg starts here
	a = AddAsteroidWithAttribs(2850,0, 0.15,0.15,0.5)
	a.Owner = 2
	a.TreeCap = 1
	a.SpawnCap = 2000
	a.SeedlingCap = 2000
	a:SetRadius(150)
	a:Reveal(1)
	
	
	a:AddSeedlings(401)
	a.SendDistance = 3000
	a.Moveable = false
	
	
	-- Asteroid 2 - the barricade
	a = AddAsteroidWithAttribs(5210,590, 0.3,0.2,0.5)
	a.Owner = 2
	a.TreeCap = 2
	a.SpawnCap = 2000
	a.SeedlingCap = 2000
	a:SetRadius(200)
	a:Reveal(1)
	
	a:AddSuperSeedlings(155)	
	a.SendDistance = 3000
	a.Moveable = false
	
	
	
	-- Asteroid 3 - large zerg starts here, also farmland for lvl 3
	a = AddAsteroidWithAttribs(7040,1810, 0.3,0.4,0.5)
	a.Owner = 2
	a.TreeCap = 3
	a.SpawnCap = 2000
	a.SeedlingCap = 2000
	a:SetRadius(250)
	a:Hide(1)
	
	a:AddSuperSeedlings(500)	
	a.SendDistance = 3000
	a.Moveable = false	
	


	
	-- Asteroid 4 - lvl 3 farmland
	a = AddAsteroidWithAttribs(8300,3700, 0.6,0.4,0.5)
	a.Owner = 2
	a.TreeCap = 4
	a.SpawnCap = 2000
	a.SeedlingCap = 2000
	a:SetRadius(350)
	a:Hide(1)
	
	a.SendDistance = 3000
	a.Moveable = false
	
	
	-- Asteroid 5 - lvl 3 farmland
	a = AddAsteroidWithAttribs(8950,6300, 0.5,0.7,0.5)
	a.Owner = 2
	a.TreeCap = 5
	a.SpawnCap = 2000
	a.SeedlingCap = 2000
	a:SetRadius(400)
	a:Hide(1)
	
	a.SendDistance = 5250
	a.Moveable = false	
	
	
	
	-- Asteroid 6 - lvl 3 farmland
	a = AddAsteroidWithAttribs(8950,9650, 0.6,0.6,0.6)
	a.Owner = 2
	a.TreeCap = 6
	a.SpawnCap = 2000
	a.SeedlingCap = 2000
	a:SetRadius(450)
	a:Hide(1)
	
	a.SendDistance = 3000
	a.Moveable = false		


	-- Asteroid 7 - lvl 3 temporary frontline. the send distance gets increased when the level is over)
	a = AddAsteroidWithAttribs(9640,12410, 0.8,0.4,0.7)
	a.Owner = 2
	a.TreeCap = 7
	a.SpawnCap = 2000
	a.SeedlingCap = 2000
	a:SetRadius(500)
	
	boobytreeone = a:AddDefenseTree()
	boobytreeone:LevelUp()
	boobytreeone:LevelUp()
	boobytreeone:LevelUp()
	boobytreetwo = a:AddDefenseTree()
	boobytreetwo:LevelUp()
	boobytreetwo:LevelUp()
	boobytreetwo:LevelUp()
	s = a:AddDefenseTree()
	s = a:AddDefenseTree()
	s = a:AddDefenseTree()
	s = a:AddDefenseTree()
	s = a:AddDefenseTree()
	
	a:Hide(1)

	a.SendDistance = 3000
	a.Moveable = false


	-- Asteroid 8 - this will be revealed and a lot of enemys will start passing through here once the player colonises Asteroid 4, thus entering the level 3 area.
	a = AddAsteroidWithAttribs(13250,16000, 0.8,0.6,0.5)
	a.Owner = 2
	a.TreeCap = 8
	a.SpawnCap = 2000
	a.SeedlingCap = 2000
	a:SetRadius(550)
	a:Hide(1)

	a.SendDistance = 4750
	a.Moveable = false


	
	-- Asteroid 9 - this is where the empire 2 seedlings actually spawn during the level 3 phase.  Also the the tree-dependent size-changing asteroid.
	a = AddAsteroidWithAttribs(16250,16750, 0.8,0.8,0.8)
	a.Owner = 2
	a.TreeCap = 9
	a.SpawnCap = 2000
	a.SeedlingCap = 2000
	a:SetRadius(600)
	a:Hide(1)


	a.SendDistance = 3000
	a.Moveable = false	
	
	
	-- Asteroid 10 - this is the dead bridge asteroid
	a = AddAsteroidWithAttribs(11060,14540, 0.1,0.1,0.1)
	a.Owner = 2
	a.TreeCap = 0
	a.SpawnCap = 2000
	a.SeedlingCap = 2000
	a:SetRadius(0)
	a:Hide(1)
	

	a.SendDistance = 4750
	a.Moveable = false
	
	
	
	
	-- Asteroid 11 - the pulsar
	a = AddAsteroidWithAttribs(20100,16750, 0.9,0.9,0.7)
	a.Owner = 2
	a.TreeCap = 10
	a.SpawnCap = 2000
	a.SeedlingCap = 2000
	a:SetRadius(650)
	a:Hide(1)


	a.SendDistance = 3000
	a.Moveable = false	
	
	
	
		-- Asteroid 12 - the reinforcements asteroid
	a = AddAsteroidWithAttribs(24050,16750, 0.9,0.9,0.9)
	a.Owner = 1
	a.TreeCap = 11
	a.SpawnCap = 4000
	a.SeedlingCap = 4000
	a:SetRadius(700)
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s.Enhanced = true
	
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s.Enhanced = true
	
	a:Hide(1)


	a.SendDistance = 9000
	a.Moveable = false	
	
	
	
		-- Asteroid 13 - THE BIG ONE!!  the mines are named so that they can be destroyed when player takes this roid over.
	a = AddAsteroidWithAttribs(31050,21000, 0.99,0.99,0.99)
	a.Owner = 2
	a.TreeCap = 13
	a.CoreHealth = 1000
	a.SpawnCap = 4000
	a.SeedlingCap = 4000
	a:SetRadius(3000)

	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	deadlymineone = s:AddFlower()
	deadlymineone:GrowToMax()
	deadlymineone:Pluck()
	
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	deadlyminetwo = s:AddFlower()
	deadlyminetwo:GrowToMax()
	deadlyminetwo:Pluck()
	
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	deadlyminethree = s:AddFlower()
	deadlyminethree:GrowToMax()
	deadlyminethree:Pluck()

	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	deadlyminefour = s:AddFlower()
	deadlyminefour:GrowToMax()
	deadlyminefour:Pluck()

	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	deadlyminefive = s:AddFlower()
	deadlyminefive:GrowToMax()
	deadlyminefive:Pluck()

	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	deadlyminesix = s:AddFlower()
	deadlyminesix:GrowToMax()
	deadlyminesix:Pluck()

	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()

	
	
	--Reveal all to empire 2, so he has no problems with sending seeds places
	GetAsteroid(0):Reveal(2)
	GetAsteroid(1):Reveal(2)
	GetAsteroid(2):Reveal(2)
	GetAsteroid(3):Reveal(2)
	GetAsteroid(4):Reveal(2)
	GetAsteroid(5):Reveal(2)
	GetAsteroid(6):Reveal(2)
	GetAsteroid(7):Reveal(2)
	GetAsteroid(8):Reveal(2)
	GetAsteroid(9):Reveal(2)
	
	
	
	
	
	
	
	SetCameraPositionToAsteroidID(0)
	SetCameraZoomNow(4)
	
	SetDysonTreeButtonAvailable(false)
	

	end


function LevelLogic()

	-- hello scripters and welcome to fluffy land, otherwise known as Function Level Logic.  This is where all the magic happens ! :>
	
	-- If you're reading this in Windows Notepad, I strongly suggest googling for Notepad ++ which is free and awesome.
	
	-- So yea... if you're new to this, have a read, and see if you can square what you see here with what is happening when you play the game.
	-- The commands do sort of make sense in english, it's really not that hard to figure out that MessageBox() causes a message box to pop up,
	-- for example.  ask on teh forum if you need halp.  http://www.dyson-game.com/smf/
	-- annikk.exe
	
	
	-- send a scout..
		GetAsteroid(1):SendSeedlingsToTarget(2,1,GetAsteroid(0))

	

	
	-- a long and painful list of variables
	Timer = GetGameTime() + 10
	greet = 0
	leveltwo = 0
	leveloneover = 0
	guide = 0
	dys = 0
	levelthree = 0
	wavenumber = 0
	WaveTimer = GetGameTime()
	boobymines = 0
	leveltwofail = 0
	FrontLine = GetAsteroid(7)
	foundseeds = 0
	endsequence = 0
	takenfrontline = 0
	takenroidone = 0
	


	-- the crazy spacing in the messages is so that the words wrap to the next line.  Can someone please let me know if this looks really stupid on your screen, annikk[dot]exe[at]gmail[dot]com

	
	while wavenumber == 0 do

		if greet == 0 and GetGameTime() > Timer - 5 then
		
			Pause()
			MessageBox("This sector is unsafe...                                   ...asteroids collapse in our wake...  Attack or defend...choose carefully.")
			WaitDialog()
			Unpause()
			
			greet = 1
			
		end
			
			
		--trigger wave 1 automatically after Timer
		if GetGameTime() > Timer and leveloneover == 0 then
		
			GetAsteroid(1):SendSeedlingsToTarget(2,80,GetAsteroid(0))
			Timer = Timer + 10
		end
	
		--guide the player to break through the barricade and take the better asteroid
		if takenroidone == 1 and guide == 0 then
			guide = 1
			GetAsteroid(0):SetRadius(0)

			Pause()
			MessageBox("The enemy stands before us as a formidable barricade.  We cannot afford to wait.  Move as one, and strike!")
			WaitDialog()
			Unpause()	
			
		end
	
	
	
		--trigger wave 2 to start (and asteroid 1 to die and hide) when the 2-tree asteroid has 2 trees on it
		if GetAsteroid(2):GetNumTrees() == 1 and leveltwo == 0 then
			
			GetAsteroid(1):SetRadius(0)
			GetAsteroid(0):SetRadius(0)
			GetAsteroid(3):Reveal(1)
			leveltwo = 1
			leveloneover = 1
			Pause()
			MessageBox("Here we must make our stand.            Plant wisely, we will need all of our strength for the coming battle.")
			WaitDialog()
			Unpause()
		end
	
		--wave 2 attack commands
		if leveltwo == 1 then
			
			leveltwo = 2
			Timer = GetGameTime() + 20
		
		end
	
		if leveltwo == 2 and GetGameTime() > Timer and GetAsteroid(3):GetNumSeedlings(2) > 0 then
			
			GetAsteroid(3):SendSeedlingsToTarget(2,100,GetAsteroid(2))
			Timer = Timer + 20
			
		end

		if leveltwofail == 1 and GetAsteroid(2):GetNumSeedlings(1) < 1 and GetAsteroid(3):GetNumTrees() < 1 then
			leveltwofail = 7
			Pause()
			MessageBox("All is lost...")
			WaitDialog()
			Unpause()
			Quit(false)
		end
		
		
		if dys == 0 and GetAsteroid(3):GetNumSeedlings(1) > 9 then
		
			SetDysonTreeButtonAvailable(true)
			dys = 1
		
		end
		
		
		
		--is level 2 over ?  can level 3 begin ?
		if leveltwo == 2 and GetAsteroid(3):GetNumSeedlings(2) < 9 and GetAsteroid(3):GetNumTrees() > 0 then
			
			leveltwo = 6
			levelthree = 1
			--send any of the players leftover seeds to the new asteroid and reveal all the asteroids in the level 3 area.
			GetAsteroid(2):SendSeedlingsToTarget(1,500,GetAsteroid(3))
			GetAsteroid(2):SetRadius(0)	
			GetAsteroid(4):Reveal(1)
			GetAsteroid(5):Reveal(1)
			GetAsteroid(6):Reveal(1)
			GetAsteroid(7):Reveal(1)
			GetAsteroid(8):Reveal(1)
			--Asteroid 9 just stays hidden for now
			
			Pause()
			MessageBox("At last, a narrow crevice of hospitable land...but perhaps not for long.  The enemy is amassing.  Colonise quickly, take the front line and prepare for battle!")
			WaitDialog()
			Unpause()			
			
			
			GetAsteroid(9):AddSeedlings(215)
			Timer = GetGameTime() + 1330
		end
		

		
			
			
		--level 3 wave 1
		if levelthree == 1 and GetGameTime() > Timer and wavenumber == 0 then
			GetAsteroid(9):SendSeedlingsToTarget(2,200,FrontLine)
			wavenumber = 1
			GetAsteroid(9):AddSuperSeedlings(120)
			WaveTimer = GetGameTime() + 15

			Pause()
			MessageBox("Here they come!  To arms, seedlings!")
			WaitDialog()
			Unpause()
		
		end
		
		if wavenumber == 0 and takenfrontline == 1 then
			takenfrontline = 2
			Pause()
			MessageBox("Now we have captured the frontline, it is time to assemble an army to defend ourselves when the first wave arrives!")
			WaitDialog()
			Unpause()
		end
		
		coroutine.yield()
	end
	
	Timer = GetGameTime() + 470
	
	
		--level 3 wave 2
	
	while GetGameTime() < Timer do
				
		coroutine.yield()
	end
	
	
	if boobymines == 1 then
	
	Pause()
	MessageBox("Laser mines!  A surprise attack, battlestations!!")
	WaitDialog()
	Unpause()
	
		SetCameraTarget(-9640,-12410)
		SetCameraZoom(5)
	end
	
	if boobymines == 0 then
	
	Pause()
	MessageBox("More seeds are coming...")
	WaitDialog()
	Unpause()
		
	end
	
	
	GetAsteroid(9):SendSeedlingsToTarget(2,120,FrontLine)
	wavenumber = 2
	GetAsteroid(9):AddSuperSeedlings(150)

	Timer = Timer + 450


	
	--the problem here is that the player may somehow have n00bed up and not been able to take asteroid 7.  This could lead to problems with erroneously giving the asteroid
	--to the player when they didn't have it before.  so to fix this we will use a variable called boobymines to check who owns it initially.  That way if empire 2 owns it,
	-- it will create friendly mines for them and they will get to keep the roid.

	-- create the booby-trap mines if the player has taken this roid.  (boobymines == 1)
	if wavenumber == 2 and boobymines == 1 then
			
			
			GetAsteroid(7):ChangeOwner(2)
			flowerone = boobytreeone:AddFlower()
			flowertwo = boobytreetwo:AddFlower()
			flowerone:GrowToMax()
			flowertwo:GrowToMax()
			flowerone:Pluck()
			flowertwo:Pluck()
			GetAsteroid(7):ChangeOwner(1)
			boobymines = 2
			
	end

	-- create the booby-trap mines if the player has NOT taken this roid (boobymines == 0)
		if wavenumber == 2 and boobymines == 0 then
		
			flowerone = boobytreeone:AddFlower()
			flowertwo = boobytreetwo:AddFlower()
			flowerone:GrowToMax()
			flowertwo:GrowToMax()
			flowerone:Pluck()
			flowertwo:Pluck()
			boobymines = 2
		
		end			
	
		
	while GetGameTime() < Timer do
		
		coroutine.yield()
	end


	--level 3 wave 3
	
	GetAsteroid(9):SendSeedlingsToTarget(2,150,FrontLine)
	wavenumber = 3
	levelthree = 2
	
	Timer = Timer + 90
	
	Pause()
	MessageBox("The final wave approaches.  Stand tall seedlings, lest we are all consumed in the great combine harvester of life.")
	WaitDialog()
	Unpause()
	

	while GetGameTime() < Timer do
		
	coroutine.yield()
	end
	


	--Warn the player that the sector is about to die
		
	wavenumber = 4
	Pause()
	MessageBox("This entire sector is about to collapse - we HAVE to push forward or we will be consumed in the blackness!")
	WaitDialog()
	Unpause()
	Timer = Timer + 60
	
	GetAsteroid(7).SendDistance = 7000

	
	while GetGameTime() < Timer and GetAsteroid(8):GetNumSeedlings(1) < 10 do
		
	coroutine.yield()
	end


		--kill the sector.
	

	wavenumber = 5
	Timer = Timer + 30
	GetAsteroid(3):SetRadius(0)
	GetAsteroid(4):SetRadius(0)
	GetAsteroid(5):SetRadius(0)
	GetAsteroid(6):SetRadius(0)
	GetAsteroid(7):SetRadius(0)
	GetAsteroid(3):Hide(1)
	GetAsteroid(4):Hide(1)
	GetAsteroid(5):Hide(1)
	GetAsteroid(6):Hide(1)
	GetAsteroid(7):Hide(1)
	
	if GetAsteroid(8):GetNumTrees() < 1 and GetAsteroid(8):GetNumSeedlings() < 9 then
		Pause()
		MessageBox("We are too late!  We have been consumed in the blackness..")
		WaitDialog()
		Quit(false)
	end
	
	


	
	while GetAsteroid(8):GetNumSeedlings(1) < 10 do
		
		coroutine.yield()
		end
	
	
	GetAsteroid(8):ChangeOwner(1)

	Pause()
	MessageBox("The sun is rising.  Asteroids ahead grow stronger as our roots touch the core.  A quasar pulses menacingly on the horizon.")
	WaitDialog()
	Unpause()


	-- bunch of new variables here... i got tired of scrolling all the way to the top.  plus, this next bit is so complicated that it's nice having them here
	
	levelfour = 0
	roidsize = 0
	roidsend = 0
	rcolour = 0
	rcolourcurrent = 0
	gcolour = 0
	gcolourcurrent = 0
	
	
	
	while levelfour == 0 do
		
		roidsend = GetAsteroid(9):GetNumTrees() * 360
				
		GetAsteroid(9).SendDistance = roidsend
		
		rcolour = GetAsteroid(9):GetNumTrees() * 11
		gcolour = GetAsteroid(9):GetNumTrees() * 4
		
		if rcolourcurrent < rcolour then
		
			rcolourcurrent = rcolourcurrent + 1
			
		end
		
		if rcolourcurrent > rcolour then
			
			rcolourcurrent = rcolourcurrent - 1
			
		end
		
		if gcolourcurrent < gcolour then
			
			gcolourcurrent = gcolourcurrent + 1
			
		end
		
		if gcolourcurrent > gcolour then
			
			gcolourcurrent = gcolourcurrent - 1
		
		end
		
		
		SetBackdropColour(rcolourcurrent,gcolourcurrent,0)

		roidsize = 300 + (math.sin(GetGameTime()) * 400)
		
		GetAsteroid(11):SetRadius(roidsize)
		
		-- that bit was a freaking pain to code.
		
		
		if GetAsteroid(12):IsVisible(1) and foundseeds == 0 then
			foundseeds = 1
			GetAsteroid(12):AddSuperSeedlings(1000)
			Pause()
			MessageBox("Welcome, ally.  We are poised to strike.  Amass an army and we shall reclaim our homeland!")
			WaitDialog()
			Unpause()
		end
		

		
		
		coroutine.yield()
		end

		-- line up mines, if any of you are still alive... ready for destruction.  player is about to win !  variables are so that the game doesn't horribly lag as it continously meets
		-- the conditions of the if statements and tries to kill a mine it already destroyed.
		
		timer = GetGameTime()
		vigt = 0
		one = 0
		two = 0
		three = 0
		four = 0
		five = 0
		six = 0
		
	while endsequence == 0 do
		
		-- mine explosions
		
		if GetGameTime() > timer + 1 and one == 0 then
			deadlymineone:Die()
			one = 1
		end
		
		if GetGameTime() > timer + 2 and two == 0 then
			deadlyminetwo:Die()
			two = 1
		end
		
		if GetGameTime() > timer + 3 and three == 0 then
			deadlyminethree:Die()
			three = 1
		end
			
		if GetGameTime() > timer + 4 and four == 0 then
			deadlyminefour:Die()
			four = 1
		end
		
		if GetGameTime() > timer + 5 and five == 0 then
			deadlyminefive:Die()
			five = 1
		end
			
		if GetGameTime() > timer + 6 and six == 0 then
			deadlyminesix:Die()
			six = 1
		end
		
		
		
		-- Grow the vignette from min to max over 13 sec (i didnt implement this in the end...the syntax is a mystery to me...but i still used a variable i was going to use for vignette to set the background colour)
		
		vigt = vigt + 1
		

		
		
		
		
		-- Fade the background colour to white
		
		SetBackdropColour(0,vigt,vigt)
		
		
		if GetGameTime() > timer + 9 then
			endsequence = 1
			Pause()
			MessageBox("We have retaken fluffy land!")
			WaitDialog()
			Unpause()
			Quit(true)
		end
		
		coroutine.yield()
	end
	
		
		-- Asteroid 10 is used as the dead bridge !!!!  Asteroid 9 and 11 are adjacent.
	
	
		
		
		
		
	

		
		


end

function OnAsteroidTaken(id, owner)

	-- the mystical OnAsteroidTaken section...  unstable power..  if you're wondering how a While loop up in Function Level Logic is supposed
	-- to reach an end or something like that, your answer probably lies below.

	if id == 1 and owner == 1 then
		GetAsteroid(0):SendSeedlingsToTarget(1,2000,GetAsteroid(1))
		takenroidone = 1
		GetAsteroid(0):Die()
		return
	end

	if id == 2 and owner == 1 then
		GetAsteroid(0):SendSeedlingsToTarget(1,2000,GetAsteroid(2))
		GetAsteroid(1):SendSeedlingsToTarget(1,2000,GetAsteroid(2))
		GetAsteroid(1):Die()
		return
	end

	if id == 3 and owner == 1 then
		GetAsteroid(0):SendSeedlingsToTarget(1,2000,GetAsteroid(3))
		GetAsteroid(1):SendSeedlingsToTarget(1,2000,GetAsteroid(3))
		GetAsteroid(2):SendSeedlingsToTarget(1,2000,GetAsteroid(3))
		GetAsteroid(2):Die()
		FrontLine = GetAsteroid(3)
		return
	end

	if id == 4 and owner == 1 then
		GetAsteroid(0):SendSeedlingsToTarget(1,2000,GetAsteroid(3))
		GetAsteroid(1):SendSeedlingsToTarget(1,2000,GetAsteroid(3))
		GetAsteroid(2):SendSeedlingsToTarget(1,2000,GetAsteroid(3))
		GetAsteroid(3):SendSeedlingsToTarget(1,2000,GetAsteroid(3))
		FrontLine = GetAsteroid(4)
		return
	end

	if id == 5 and owner == 1 then
	
		GetAsteroid(0):Hide(1)
		
	
		GetAsteroid(1):Hide(1)
		
	
		GetAsteroid(2):Hide(1)
		
		FrontLine = GetAsteroid(5)
		
		return
	end

	if id == 6 and owner == 1 then
		
		FrontLine = GetAsteroid(6)
		
		return
	end
	
	if id == 7 and owner == 1 then
		boobymines = 1
		FrontLine = GetAsteroid(7)
		takenfrontline = 1
		return
	end

	if id == 8 and owner == 1 then
		
		return
	end
	
	

	if id == 13 and owner == 1 then
		levelfour = 1
		return
	end
	
	

	
	if id == 2 and owner == 2 then
		leveltwofail = 1
		return
	end
	
	if id == 3 and owner == 2 then
		Quit(false)
		return
	end	

	if id == 4 and owner == 2 then
		GetAsteroid(4):SendSeedlingsToTarget(2,2000,GetAsteroid(3))
		GetAsteroid(5):SendSeedlingsToTarget(2,2000,GetAsteroid(3))
		GetAsteroid(6):SendSeedlingsToTarget(2,2000,GetAsteroid(3))
		GetAsteroid(7):SendSeedlingsToTarget(2,2000,GetAsteroid(3))
		FrontLine = GetAsteroid(3)
		return
	end	
	
	if id == 5 and owner == 2 then
		GetAsteroid(5):SendSeedlingsToTarget(2,2000,GetAsteroid(4))
		GetAsteroid(6):SendSeedlingsToTarget(2,2000,GetAsteroid(4))
		GetAsteroid(7):SendSeedlingsToTarget(2,2000,GetAsteroid(4))
		FrontLine = GetAsteroid(4)
		return
	end
	
	if id == 6 and owner == 2 then
		GetAsteroid(6):SendSeedlingsToTarget(2,2000,GetAsteroid(5))
		GetAsteroid(7):SendSeedlingsToTarget(2,2000,GetAsteroid(5))
		FrontLine = GetAsteroid(5)
		return
	end
	
	if id == 7 and owner == 2 then
		GetAsteroid(7):SendSeedlingsToTarget(2,2000,GetAsteroid(6))
		FrontLine = GetAsteroid(6)
		boobymines = 0
		return
	end
		
		
end