function LevelSetup()


	SetBackdropColour(252,222,200)

	Globals.Agents.MaxSpeed=600
	Globals.Agents.MinSpeed=130

	Globals.Asteroids.MaxTrees=4
	Globals.Asteroids.MinRadius=95
    Globals.Asteroids.MaxRadius=725
    Globals.Asteroids.RadiusPowerRule=1.5
	Globals.Asteroids.SizeFromEnergy=210
	Globals.Asteroids.SizeFromStrength=210
	Globals.Asteroids.SizeFromSpeed=210
	Globals.Asteroids.MinCoreHealth=500
	Globals.Asteroids.MaxCoreHealth=750
	Globals.Asteroids.CoreHealthPower=3.5
    Globals.Asteroids.MinSendDistance=2000
    Globals.Asteroids.MaxSendDistance=5000
    Globals.Asteroids.SendPowerRule=1.4
	Globals.Asteroids.SpawnCap=200
	Globals.Asteroids.SeedlingCap=1000

	Globals.AI.MinAttackTime=(5)
	Globals.AI.MaxAttackTime=(20)
	Globals.AI.MinGatherTime=(10)
	Globals.AI.MaxGatherTime=(20)
	Globals.AI.MinScoutTime=(1)
	Globals.AI.MaxScoutTime=(5)
	Globals.AI.GraceTimer=(30)


	Globals.G.EnemyFactionsMin=(1)
	Globals.G.EnemyFactionsMax=(1)
	Globals.G.MinAsteroidSeparation=1350
	Globals.G.MaxAsteroidNeighbourDist=5500
	Globals.G.StartingSeedlings=(0)
	Globals.G.GreysProbability=0

	Globals.Structures.FlowerProbability=(0.3)

	--#0 Enemy launchpad
	EnemyBase = AddAsteroidWithAttribs(16000, -2000, 0.7, 0.5, 1.0)
	EnemyBase.Owner = 2
	EnemyBase.SendDistance = 21000
	EnemyBase.Moveable = false
	EnemyBase.TreeCap = 6
	EnemyBase:AddSeedlings(150)
	a = EnemyBase
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()



	--#1 Friendly Base
	a = AddAsteroidWithAttribs(0, -1500, 0.5, 0.7, 0.7)
	a.Owner = 1
	a.TreeCap = 7
	a.SendDistance = 6000
	a.Moveable = false
	a:Reveal(1)
	a:AddSeedlings(100)
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()


	--#2 Friendly Base
	a = AddAsteroidWithAttribs(1000, 1500, 0.8, 0.4, 0.6)
	a.Owner = 1
	a.TreeCap = 7
	a.SendDistance = 6000
	a.Moveable = false
	a:Reveal(1)
	a:AddSeedlings(50)
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:AddFlower()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()


	--#3 Friendly Base
	a = AddAsteroidWithAttribs(-1000, 0, 0.4, 0.7, 0.8)
	a.Owner = 1
	a.TreeCap = 7
	a.SendDistance = 6000
	a.Moveable = false
	a:Reveal(1)
	a:AddSeedlings(25)
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	LaserMine = s:AddFlower()
	LaserMine:GrowToMax()
	LaserMine:Pluck()


	--#4 Friendly Base
	a = AddAsteroidWithAttribs(2000, -500, 0.6, 0.8, 0.4)
	a.Owner = 1
	a.TreeCap = 7
	a.SendDistance = 6000
	a.Moveable = false
	a:Reveal(1)
	a:AddSeedlings(25)
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	LaserMine = s:AddFlower()
	LaserMine:GrowToMax()
	LaserMine:Pluck()


	--#5 Enemy Minefield
	a = AddAsteroidWithAttribs(13000, -1000, 0.8, 0.8, 0.8)
	a.TreeCap = 10
	a.owner=2

	for i=1,10 do
		s = a:AddDefenseTree()
		s:LevelUp()
		s:LevelUp()
		s:LevelUp()
		s:LevelUp()
		LaserMine = s:AddFlower()
		LaserMine:GrowToMax()
		LaserMine:Pluck()

	end

	--Figured out that if you don't specify an empty Asteroid Ring the game will automatically throw a bunch in there.
	--Asteroid Ring
	AddAsteroidRing(16, 6000, -500, 4000, 1000)

	SetCameraPositionToAsteroidID(1)
	SetCameraZoomNow(9)


end

function LevelLogic()

	Reinforcements = 1
	Timer = 90
	Target = GetRandomRangeAsteroid(1, 5)

	--AI experimentation
	GetAI(2).Cowardice = 0.05
	GetAI(2).MinExpansionForce = 30


	Pause()
	MessageBox("The Hive has sensed a disturbance at the edge of our empire, we have seeded trees through this asteroid belt.\n\nDefend your home asteroids from the incoming invasion.")
	WaitDialog()
	Unpause()

	Pause()
	MessageBox("Lose all four of your bases before twenty minutes and you lose, survive that long and you win.")
	WaitDialog()
	Unpause()




	while GameRunning() do


		if GetGameTime() > Timer then

			Timer = Timer + 90

			Target = GetRandomRangeAsteroid(1, 5)
			while Target.Owner ~= 1 do
				Target = GetRandomRangeAsteroid(1, 5)
				coroutine.yield()
			end

			Reinforcements = GetEmpire(1).NumSeedlings + 25

			if Reinforcements < 150 then
				Reinforcements = 150
			end


			if GetGameTime() < 300 then
				Reinforcements = Reinforcements * 0.7
			end

			if GetGameTime() > 700 then
				Reinforcements = (Reinforcements * 1.25) + 75
			end

			EnemyBase:AddSeedlings(Reinforcements)

			EnemyBase:SendSeedlingsToTarget(2, Reinforcements, Target)
		end



		--Win Condition
		if GetGameTime() > 1200 then
			Pause()
			MessageBox("Congratulations.  You have survived the enemy invasion!  Thanks to your work the Hive has had time to research our new foe.")
			WaitDialog()
			Unpause()
			Quit(true)
		end

		--Lose Condition
		if  GetAsteroid(1).Owner==2 and GetAsteroid(2).Owner==2 and GetAsteroid(3).Owner==2 and GetAsteroid(4).Owner==2 then
--		if GetEmpire(1):GetNumOwnedAsteroids() == 0 then
			Pause()
			MessageBox("We have lost our foothold in this system...")
			WaitDialog()
			Unpause()
			Quit(false)
		end


		coroutine.yield()
	end
end


