function LevelSetup()

-- Visos funkcijos testuojamos. Globalus dar gali keistis arbu ju nebus
	SetBackdropColour(100,222,200)

	Globals.Agents.MaxSpeed=800
	Globals.Agents.MinSpeed=100
	Globals.Asteroids.MaxTrees=2
	Globals.Structures.TreeCost=10
	Globals.StructuresDefense.TreeCost=6

	Globals.Asteroids.MinRadius=50
    Globals.Asteroids.MaxRadius=150
    Globals.Asteroids.RadiusPowerRule=0.8
	Globals.Asteroids.SizeFromEnergy=300
	Globals.Asteroids.SizeFromStrength=250
	Globals.Asteroids.SizeFromSpeed=200

	Globals.Asteroids.MinCoreHealth=200
	Globals.Asteroids.MaxCoreHealth=800
	Globals.Asteroids.CoreHealthPower=4.0
	Globals.Asteroids.SendPowerRule=1.0
	Globals.Asteroids.AttributeDivisions=3

--Maziausias keliavimo atstumas tarp asteroidu
    Globals.Asteroids.MinSendDistance=250
	--Didziausias keliavimo atstumas tarp asteroidu
    Globals.Asteroids.MaxSendDistance=350

--Maziausias atstumas tarp asteroidu
	Globals.G.MinAsteroidSeparation=200
--Didziausias atstumas tarp asteroidu
	Globals.G.MaxAsteroidNeighbourDist=550

	Globals.AI.MinAttackTime=(3)
	Globals.AI.MaxAttackTime=(8)
	Globals.AI.MinGatherTime=(5)
	Globals.AI.MaxGatherTime=(10)
	Globals.AI.MinScoutTime=(1)
	Globals.AI.MaxScoutTime=(5)
	Globals.AI.GraceTimer=(1)


	Globals.G.EnemyFactionsMin=(1)
	Globals.G.EnemyFactionsMax=(1)



	Globals.G.StartingSeedlings=(35)
	Globals.G.GreysProbability=0

	Globals.Structures.FlowerProbability=(0.1)

-- Asteroidas 0
-- Cia yra zaidejo asteroidas
	a = AddAsteroidWithAttribs(0,0, 0.5,0.5,0.6)
	a.Owner = 1
	a.TreeCap = 2
	a:SetRadius(300)
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	a:AddSeedlings(30)
	a.SendDistance = 700
	a.Moveable = false
	SetCameraZoomNow(4)

--Asteroidu ratas (Kiekis, X, Y, Asies atstumas nuo X, Issidestymas??)
	AddAsteroidRing(4, 0, 0, 100, 0)

-- Asteroidas 5
-- Cia yra kompiuterio asteroidas
	a = AddAsteroidWithAttribs(800,100, 1.0,1.0,0.7)
	a.Owner = 2
	a.TreeCap = 6
	a:SetRadius(300)
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	a.SendDistance = 700
	a.Moveable = false
	a:AddSeedlings(5)


	end


function LevelLogic()
--Kur yra priesu baze nr1
	Priesubaze1 = GetAsteroid(5)

--Kazkodel atidengia asteroida, bet neaisku kam jis..
	Asteroidas4 = GetAsteroid(4)

--Jeigu neparasysiu, tada pralaimes
	win = false

	Storytxt = 1

--AI mastymas
	GetAI(2).Cowardice = 0.01
	GetAI(2).MinExpansionForce = 15
	GetAI(2).BattleSavvy = 0.3
	GetAI(2).ReinforcementGreed = 0.8
	GetAI(2).GreedyExpansion = 0.4
	GetAI(2).AidEnthusiasm = 1.8

	Pause()
	MessageBox("Run from your home, Find your ally and Conquer other giant enemy asteroid to Win!")
	WaitDialog()
	Unpause()



--Nustatomas taikinys (Jei ji nukausiu, laimesiu)
function OnAsteroidTaken(id, owner)
	if id == 5 and owner == 1
		then
			win = 1
	elseif id == 0 and owner ~= 1
		then
			win = 0
	end
end

while GameRunning() do

--Kelias nurodo bloga ejima (i prazuti)
	if Storytxt == 2
		then
			Storytxt = 1
			Pause()
			MessageBox("You choosed your destiny! Path: 2")
			WaitDialog()
			Unpause()
			Asteroidas4:Reveal(1)
	end

--Kelias rodo gera ejima (i alijanca)
	if Storytxt == 3
		then
			Storytxt = 1
			Pause()
			MessageBox("Fly away faster if u can!! Path: 3")
			WaitDialog()
			Unpause()
	end

--Nustatoma zinute, jeigu taikinys nukautas (Pergale)
	if win == 1
		then
			Pause()
			MessageBox("You WIN.")
			WaitDialog()
			Unpause()
			Quit(true)
		end
--Nustatoma zinute, jeigu taikinys nenukautas (Pralaimejimas)
	if win == 0
		then
			Pause()
			MessageBox("You LOSE.")
			WaitDialog()
			Unpause()
			Quit(false)
		end
		coroutine.yield()

--Nustatomas asteroidas, jeigu ji uzimsiu rasys path2
function OnAsteroidRevealed(id, owner)
	if id == 2 and owner == 1
		then
			Storytxt = 2
	end
end

--Nustatomas asteroidas, jeigu ji uzimsiu rasys ar as tuo tikras
function OnAsteroidTaken(id, owner)
	if id == 3 and owner == 1
		then
			Storytxt = 3
	end
end

--Turbut uzdaromas Gamerunning
end
--Turbut uzdaromas Levelogic
end







