--Map: The Broken Belt

--Info: Hard, includes Alien AI V1.1
--Additional Info: Longlasting, replayable...

function LevelSetup()

	Globals.G.Asteroids=0
	Globals.G.EnemyFactionsMin=0
	Globals.G.EnemyFactionsMax=0
	Globals.Structures.FlowerProbability = 0.00
	Globals.Asteroids.SizeFromEnergy = 50
	Globals.Asteroids.SizeFromStrength = 50
	Globals.Asteroids.SizeFromSpeed = 50
	Globals.Asteroids.RadiusPowerRule = 1
	Globals.G.GreysProbability = 0.00
	Globals.G.GreysMin=0
	Globals.G.GreysMax=0
	
	ERRoid = {}
	ERRoidNumber = 0
	AddRoid(0,-4500,			0.5,0.6,0.55,	0,2,0,	2500,	0,0,false,nil)--ID0
	AddRoid(-2000,-3000,		0.6,0.6,0.6,	0,2,0,	2750,	0,0,false,nil)
	AddRoid(-4000,-5000,		0.7,0.5,0.6,	0,2,0,	3500,	0,0,false,nil)
	AddRoid(-7000,-3500,		0.8,0.5,0.65,	0,3,0,	2500,	0,0,false,nil)
	AddRoid(-9000,-4000,		0.6,0.6,0.65,	0,3,0,	1000,	0,0,false,nil)
	AddRoid(-9000,-3000,		0.6,0.6,1.0,	0,3,0,	3500,	0,0,false,nil)--ID5
	AddRoid(-11000,0,			0.55,0.65,0.8,	0,4,0,	4100,	0,0,false,nil)
	AddRoid(-8000,3000,			0.5,0.65,0.65,	0,4,0,	4100,	0,0,false,nil)
	AddRoid(-4500,-100,			0.5,0.65,0.65,	0,4,0,	4000,	0,0,false,nil)
	AddRoid(-4500,3000,			0.5,0.8,0.6,	2,5,0,	3550,	50,0,false,nil)
	AddTree(-1,"dys",4)
	AddRoid(-3000,4000,			0.45,0.6,0.6,	0,4,0,	2500,	0,0,false,nil)--ID10
	AddRoid(-1000,2250,			0.45,0.55,0.65,	0,4,0,	2750,	0,0,false,nil)
	AddRoid(-2750,5750,			0.5,0.55,0.65,	0,4,0,	2500,	0,0,false,nil)
	AddRoid(1250,4000,			0.4,0.6,0.65,	0,4,0,	2750,	0,0,false,nil)
	AddRoid(2250,5750,			0.5,0.6,0.7,	0,3,0,	2500,	0,0,false,nil)
	AddRoid(3750,3000,			0.35,0.65,0.7,	0,3,0,	2550,	0,0,false,nil)--ID15
	AddRoid(5000,3750,			0.4,0.6,0.7,	0,3,0,	2500,	0,0,false,nil)
	AddRoid(5000,2350,			0.4,0.6,0.7,	0,2,0,	2500,	0,0,false,nil)
	AddRoid(7250,3000,			0.6,0.5,0.65,	0,2,0,	2550,	0,0,false,nil)
	AddRoid(7000,5750,			0.7,0.45,0.6,	0,3,0,	2850,	0,0,false,nil)
	AddRoid(9000,1250,			0.7,0.5,0.55,	0,3,0,	2500,	0,0,false,nil)--ID20
	AddRoid(10000,-500,			0.65,0.55,0.5,	0,3,0,	2500,	0,0,false,nil)
	AddRoid(8500,-2000,			0.6,0.6,0.5,	0,4,0,	2500,	0,0,false,nil)
	AddRoid(9500,-3000,			0.5,0.5,0.5,	0,4,0,	2500,	0,0,false,nil)
	AddRoid(7500,-3000,			0.5,0.5,0.5,	0,4,0,	2500,	0,0,false,nil)
	AddRoid(8500,-5000,			0.4,0.55,0.5,	1,5,0,	2500,	50,0,false,nil)--ID25
	AddTree(-1,"dys",4)
	AddRoid(8750,-6500,			0.7,0.6,0.3,	0,4,0,	2500,	0,0,false,nil)
	AddRoid(7500,-7000,			0.7,0.7,0.4,	0,4,0,	2500,	0,0,false,nil)
	AddRoid(6000,-6500,			0.8,0.7,0.5,	0,4,0,	2000,	0,0,false,nil)
	AddRoid(10000,-5000,		0.2,0.5,0.6,	0,3,0,	2500,	0,0,false,nil)
	AddRoid(12000,-5500,		0.4,0.5,0.8,	0,3,0,	2500,	0,0,false,nil)--ID30
	AddRoid(14000,-6000,		0.6,0.5,1.0,	0,3,0,	2500,	0,0,false,nil)
	AddRoid(5750,-4000,			0.5,0.5,0.5,	0,2,0,	2000,	0,0,false,nil)
	AddRoid(5000,-4750,			0.55,0.55,0.55,	0,2,0,	1500,	0,0,false,nil)
	AddRoid(4250,-4000,			0.6,0.6,0.6,	0,2,0,	2500,	0,0,false,nil)
	AddRoid(1750,-4000,			0.5,0.6,0.55,	0,1,0,	2500,	0,0,false,nil)--ID35
	
	AAIInit()
	
end

function LevelLogic()

	Pause()
	MessageBox("The asteroid belt is destroyed, all the asteroids are splitted up and only some parts still remains... And with the destruction, some Alien race showed up... We better get movin'!")
	WaitDialog()
	Unpause()
	
	while GameRunning() do
		
		AAIEngine()
		
		if GetEmpire(1):GetNumOwnedAsteroids() == 0 then
			Pause()
			MessageBox("No! No! No... How? I mean, why? Why did you let us down that way?")
			WaitDialog()
			Unpause()
			Quit(false)
		end
		if GetEmpire(2):GetNumOwnedAsteroids() == 0 then
			Pause()
			MessageBox("Yes! The alien race is gone and we are kept safe, we'll need to put this belt together though...")
			WaitDialog()
			Unpause()
			Quit(true)
		end
		
		coroutine.yield()
		
	end
end

function AddRoid(roidx,roidy, roidenergy,roidstrength,roidspeed, roidowner, roidtrees, roidradius, roidsenddist,roidseedlings, roidsuperseedlings, roidmoving, roidname)
	
	if roidenergy == 0.0 then
		roidenergy = math.random()
	end
	if roidstrength == 0.0 then
		roidstrength = math.random()
	end
	if roidspeed == 0.0 then
		roidspeed = math.random()
	end
	
	ERRoid[ERRoidNumber] = AddAsteroidWithAttribs(roidx,roidy, roidenergy, roidstrength, roidspeed)
	ERRoid[ERRoidNumber].Owner = roidowner
	ERRoid[ERRoidNumber].TreeCap = roidtrees
	if roidradius > 10 then
		ERRoid[ERRoidNumber]:SetRadius(roidradius)
	end
	if roidsenddist > 10 then
		ERRoid[ERRoidNumber].SendDistance = roidsenddist
	end
	ERRoid[ERRoidNumber]:AddSeedlings(roidseedlings)
	ERRoid[ERRoidNumber]:AddSuperSeedlings(roidsuperseedlings)
	ERRoid[ERRoidNumber].Moveable = roidmoves
	if roidname ~= nil then
	ERRoid[ERRoidNumber].Name = roidname
	end
	if 	ERRoid[ERRoidNumber].Owner == 1 then
		ERRoid[ERRoidNumber]:Reveal(1)
	end
	
	ERRoidNumber = ERRoidNumber + 1
end

function AddTree(roidnumber, treetype, treelevel)

	if roidnumber == -1 then
		roidnumber = ERRoidNumber-1
	end
	
	if treetype == "dys" or treetype == "dyson" then
		temptree = ERRoid[roidnumber]:AddDysonTree()
	elseif treetype == "def" or treetype == "defense" then
		temptree = ERRoid[roidnumber]:AddDefenseTree()
	end
	if treelevel > 0 and treelevel < 5 then
		for treelevel = 1, treelevel do
			temptree:LevelUp()
		end
	elseif treelevel == 5 then
		for treelevel = 1, 4 do
			temptree:LevelUp()
		end
		temptree:AddFlower()
	end
	
end

function AAIInit()
	
	Empire = 2	--Which AI empire should the AI control?
	
	Globals.AI.GraceTimer = 9999999
	AAINumRoids = -1
	AAISelectedRoid = 0
	AAIPriority = {}
	AAINo_Priority = false
	AAILastCheckedOwner = {}
	AAITakeBack = {}
	AAITakeBackTimer = {}
	AAIHaveRoots = {}
	
	for i = 0,100000 do
		if GetAsteroid(i) ~= nil then
			
			AAINumRoids = AAINumRoids + 1
			AAIPriority[i] = 0
			AAITakeBack[i] = false
			AAILastCheckedOwner[i] = GetAsteroid(i).Owner
			AAIHaveRoots[i] = false
		
		else
		
			break
			
		end
		
	end
	
end

function AAIEngine()
	
	local HighestEnergy = 0
	local HighestStr = 0
	local HighestSpeed = 0
	
	for i = 0,AAINumRoids do
		if GetAsteroid(i).owner ~= Empire then
			GetAsteroid(i):SetGraceTime(0)
		else
			GetAsteroid(i):SetGraceTime(99999)
			if GetAsteroid(i).attribs.energy > HighestEnergy then
				
				HighestEnergy = GetAsteroid(i).attribs.energy
				
			end
			
			if GetAsteroid(i).attribs.strength > HighestStr then
				
				HighestStr = GetAsteroid(i).attribs.strength
				
			end
			
			if GetAsteroid(i).attribs.speed > HighestSpeed then
				
				HighestSpeed = GetAsteroid(i).attribs.speed
				
			end
			if AAIHaveRoots[i] == false and GetAsteroid(i):GetNumTrees() > 0 then
			
				AAIHaveRoots[i] = true
			
			end
		end
	end
	
	AAISelectedRoid = math.random(0,AAINumRoids)
	local Numneighbours = 0
	local Neighbour = {}
	
	local ChangedOwner = false
	
	if GetAsteroid(AAISelectedRoid).Owner ~= AAILastCheckedOwner[AAISelectedRoid] then
	
		ChangedOwner = true
		
	end
	
	if ChangedOwner == true and AAILastCheckedOwner[AAISelectedRoid] == Empire then
		
		AAITakeBack[AAISelectedRoid] = true
		AAITakeBackTimer[AAISelectedRoid] = GetGameTime() + 30
		
	end
	
	if ChangedOwner == true and AAITakeBack[AAISelectedRoid] == true and AAILastCheckedOwner[AAISelectedRoid] ~= Empire and GetAsteroid(AAISelectedRoid).Owner == Empire then
		
		AAITakeBack[AAISelectedRoid] = false
		AAITakeBackTimer[AAISelectedRoid] = nil
		
	end
	
	if AAITakeBackTimer[AAISelectedRoid] ~= nil then
		if GetGameTime() > AAITakeBackTimer[AAISelectedRoid] then
			AAITakeBack[AAISelectedRoid] = false
			AAITakeBackTimer[AAISelectedRoid] = nil
		end
	end
	
	--Flowertime :D No seriously -.-
	
	local Tree = GetAsteroid(AAISelectedRoid):GetRandomDysonTree()
	
	if Tree ~= nil then
	
		Flower = Tree:GetSuperSeedling()
		
	end
	
	if Flower ~= nil and GetAsteroid(AAISelectedRoid).Owner == Empire then
	
		Flower:Pluck()
		
	end
	
	local Flower = GetAsteroid(AAISelectedRoid):GetFlower(Empire)
	
	if Flower ~= nil and GetAsteroid(AAISelectedRoid).Owner == Empire then
	
		Flower:PlantOnRandomDysonTree()
		
	end
	
	--Now as we have the selectedroid here, begin making conditions for priorities to be set...
	--First if the ERRoid is attacked, what do we do? We set the priority to zero, so the neighbours know that: "OMGosh, that ERRoid is attacked, help it!"
	if GetAsteroid(AAISelectedRoid):GetNumSeedlingsExcluding(Empire) > GetAsteroid(AAISelectedRoid):GetNumSeedlings(Empire)/4 and GetAsteroid(AAISelectedRoid).Owner == Empire and AAIPriority[AAISelectedRoid] > 0 then
		
		AAIPriority[AAISelectedRoid] = 0
		
	elseif AAITakeBack[AAISelectedRoid] == true and AAIPriority[AAISelectedRoid] ~= 0 then
		
		AAIPriority[AAISelectedRoid] = 0
	
	end
	
	if GetAsteroid(AAISelectedRoid):GetMine(1) ~= nil then
		
		AAIPriority[AAISelectedRoid] = 0
	
	end
	
	if GetAsteroid(AAISelectedRoid):GetNumTrees() < GetAsteroid(AAISelectedRoid).TreeCap and GetAsteroid(AAISelectedRoid):GetNumTrees() >= 1 and GetAsteroid(AAISelectedRoid).Owner == Empire and AAIPriority[AAISelectedRoid] > AAINumRoids*2 then
		
		AAIPriority[AAISelectedRoid] = AAINumRoids*2
		
	end
	
	if GetAsteroid(AAISelectedRoid):IsVisible(Empire) ~= true and AAIPriority[AAISelectedRoid] > AAINumRoids*4 then
		
		AAIPriority[AAISelectedRoid] = AAINumRoids*4
		
	end
	
	if GetAsteroid(AAISelectedRoid):GetNumTrees() == 0 and AAIHaveRoots[AAISelectedRoid] == false and AAIPriority[AAISelectedRoid] > AAINumRoids*6 then
		
		AAIPriority[AAISelectedRoid] = AAINumRoids*6
		
	end
	
	if GetAsteroid(AAISelectedRoid).Owner ~= Empire and GetAsteroid(AAISelectedRoid):IsVisible(Empire) == true and GetEmpire(Empire).NumSeedlings > GetAsteroid(AAISelectedRoid):GetNumSeedlingsExcluding(Empire)*1.5 and AAIPriority[AAISelectedRoid] > AAINumRoids*8 then
		
		AAIPriority[AAISelectedRoid] = AAINumRoids*8
		
	end
	
	--Now check if all of the priorities are still correct, so we can decide if we want it to refresh or not...
	
	--Are we still attacked?
	if AAIPriority[AAISelectedRoid] == 0 and GetAsteroid(AAISelectedRoid):GetNumSeedlingsExcluding(Empire) == 0 and GetAsteroid(AAISelectedRoid).Owner == Empire and AAITakeBack[AAISelectedRoid] == false and GetAsteroid(AAISelectedRoid):GetMine(1) == nil then
		
		AAIPriority[AAISelectedRoid] = AAINumRoids*10
		
	elseif AAIPriority[AAISelectedRoid] == 0 and GetAsteroid(AAISelectedRoid).Owner ~= Empire and AAIPriority[AAISelectedRoid] == 0 and AAITakeBack[AAISelectedRoid] == false then
		
		AAIPriority[AAISelectedRoid] = AAINumRoids*10
	
	end
	
	if AAIPriority[AAISelectedRoid] == AAINumRoids*2 and GetAsteroid(AAISelectedRoid):GetNumTrees() == GetAsteroid(AAISelectedRoid).TreeCap and GetAsteroid(AAISelectedRoid).Owner == Empire then
		
		AAIPriority[AAISelectedRoid] = AAINumRoids*10
		
	end
	
	if AAIPriority[AAISelectedRoid] == AAINumRoids*4 and GetAsteroid(AAISelectedRoid):IsVisible(Empire) == true then
		
		AAIPriority[AAISelectedRoid] = AAINumRoids*10
		
	end
	
	if AAIPriority[AAISelectedRoid] == AAINumRoids*6 and GetAsteroid(AAISelectedRoid):GetNumTrees() > 0 then
		
		AAIPriority[AAISelectedRoid] = AAINumRoids*10
		
	end
	
	if GetAsteroid(AAISelectedRoid).Owner == Empire and AAIPriority[AAISelectedRoid] == AAINumRoids*8 then
		
		AAIPriority[AAISelectedRoid] = AAINumRoids*10
		
	end
	
	if AAIPriority[AAISelectedRoid] == AAINumRoids*2 and GetAsteroid(AAISelectedRoid):GetNumSeedlings(Empire) >= 10 and GetAsteroid(AAISelectedRoid).Owner == Empire then
		
		GetAsteroid(AAISelectedRoid):PlantDysonTree(Empire)
		
	end
	
	if AAIPriority[AAISelectedRoid] == AAINumRoids*6 and GetAsteroid(AAISelectedRoid):GetNumSeedlings(Empire) >= 10 then
			
			local Lowerstats = 0
			if GetAsteroid(AAISelectedRoid).attribs.energy < HighestEnergy/2 then
			
				Lowerstats = Lowerstats+1
			
			end
			
			if GetAsteroid(AAISelectedRoid).attribs.strength < HighestStr/2 then
			
				Lowerstats = Lowerstats+1
			
			end
			
			if GetAsteroid(AAISelectedRoid).attribs.speed < HighestSpeed/2 then
			
				Lowerstats = Lowerstats+1
			
			end
			
			if Lowerstats >= 2 then
				
				GetAsteroid(AAISelectedRoid):PlantDefenseTree(Empire)
				
			else
				
				GetAsteroid(AAISelectedRoid):PlantDysonTree(Empire)
				
			end
			
	end
	
	local Yes_Priority = false
	AAINo_Priority = false
	local LowestPriority = AAINumRoids*10
	
	--Scanning for every empire, so everyone can see the status for the ERRoid...
	for i = 0,AAINumRoids do
		
		if AAIPriority[i] < LowestPriority then
			
			LowestPriority = AAIPriority[i]
			
		end
		
		if i ~= AAISelectedRoid then
			
			--Figuring the distance between the two roids...
			Xdif = GetAsteroid(AAISelectedRoid).position.X - GetAsteroid(i).position.X
			Ydif = GetAsteroid(AAISelectedRoid).position.Y - GetAsteroid(i).position.Y
			Dist = math.abs(math.sqrt((Xdif*Xdif)+(Ydif*Ydif)))
			
			if Dist <= GetAsteroid(AAISelectedRoid).SendDistance+GetAsteroid(i).Radius then
				--Ok, we have a neighbour, add it to the list so we can check it for several stuff later!
				Numneighbours = Numneighbours+1
				Neighbour[Numneighbours] = GetAsteroid(i)
			end
			
		end
	end
	
	for i = 1,Numneighbours do
		
		
		if AAIPriority[AAISelectedRoid] > AAIPriority[Neighbour[i].ID] and GetAsteroid(AAISelectedRoid).Owner == Empire then
			
			AAIPriority[AAISelectedRoid] = AAIPriority[Neighbour[i].ID]+1
			if AAIPriority[Neighbour[i].ID] == AAINumRoids*8 and GetAsteroid(AAISelectedRoid):GetNumSeedlings(Empire)/1.5 > Neighbour[i]:GetNumSeedlings(Neighbour[i].Owner) then
				GetAsteroid(AAISelectedRoid):SendSeedlingsToTarget(Empire, GetAsteroid(AAISelectedRoid):GetNumSeedlings(Empire), GetAsteroid(Neighbour[i].ID))
			elseif AAIPriority[Neighbour[i].ID] == 0 and GetAsteroid(AAISelectedRoid):GetNumSeedlings(Empire)/1.5 > Neighbour[i]:GetNumSeedlings(Neighbour[i].Owner) then
				GetAsteroid(AAISelectedRoid):SendSeedlingsToTarget(Empire, GetAsteroid(AAISelectedRoid):GetNumSeedlings(Empire), GetAsteroid(Neighbour[i].ID))
			elseif AAIPriority[Neighbour[i].ID] ~= AAINumRoids*8 then
				GetAsteroid(AAISelectedRoid):SendSeedlingsToTarget(Empire, GetAsteroid(AAISelectedRoid):GetNumSeedlings(Empire), GetAsteroid(Neighbour[i].ID))
			end
			Yes_Priority = true
			
		elseif AAIPriority[AAISelectedRoid]~=0 and AAIPriority[AAISelectedRoid]~=AAINumRoids*2 and AAIPriority[AAISelectedRoid]~=AAINumRoids*4 and AAIPriority[AAISelectedRoid]~=AAINumRoids*6 and AAIPriority[AAISelectedRoid]~=AAINumRoids*8 and AAIPriority[AAISelectedRoid]~=AAINumRoids*10 then
			
			AAINo_Priority = true
			
		end
	end
	
	if Yes_Priority == true and AAINo_Priority == true then
		
		AAINo_Priority = false
		
	end
			
	if AAINo_Priority == true and GetAsteroid(AAISelectedRoid).Owner == Empire then
		
		AAIPriority[AAISelectedRoid] = AAINumRoids*10
		
	end
	
	for sum = 1,5 do
		if LowestPriority < AAINumRoids*(sum*2) and LowestPriority > AAINumRoids*((sum*2)-2) and LowestPriority ~= AAINumRoids*(sum*2) then
				
			for i = 0,AAINumRoids do
				
				if AAIPriority[AAISelectedRoid] > AAINumRoids*((sum*2)-2) and AAIPriority[AAISelectedRoid] < AAINumRoids*(sum*2) then
					
					AAIPriority[AAISelectedRoid] = AAINumRoids*10
					
				end
			end
		end
	end
	
	AAILastCheckedOwner[AAISelectedRoid] = GetAsteroid(AAISelectedRoid).Owner
	
	--GetAsteroid(AAISelectedRoid).Name = AAIPriority[AAISelectedRoid]
	
end