function LevelSetup()

	-- Set Global Values
	Globals.G.Asteroids=(0)
	Globals.G.EnemyFactionsMin=(1)
	Globals.G.EnemyFactionsMax=(5)


	-- Asteroid 0 - starting asteroid
	a = AddAsteroidWithAttribs(0,0, 0.7,0.6,0.9)
	a.Owner = 1
	a.TreeCap = 4
	a:SetRadius(250)
	a.SendDistance = 2500

	a:AddSeedlings(90)



	-- Asteroid 1
	a = AddAsteroidWithAttribs(2000,0, 0.4,0.6,0.9)
	a.Owner = 2
	a.TreeCap = 6
	a:SetRadius(450)
	a.SendDistance = 2500
	
	--	a:AddTrees(0,4):LevelUp()
	Tree1 = a:AddDefenseTree()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()	
	Tree1:LevelUp()
	Tree1:LevelUp()	
	Tree2 = a:AddDefenseTree()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree3 = a:AddDefenseTree()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree4 = a:AddDefenseTree()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()


	-- Asteroid 2
	a = AddAsteroidWithAttribs(-600,2000, 0.6,0.9,0.9)
	a.Owner = 3
	a.TreeCap = 5
	a:SetRadius(400)
	a.SendDistance = 3500
	
	--	a:AddTrees(0,4):LevelUp()
	Tree1 = a:AddDefenseTree()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree2 = a:AddDefenseTree()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree3 = a:AddDefenseTree()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree4 = a:AddDefenseTree()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree5 = a:AddDefenseTree()
	Tree5:LevelUp()
	Tree5:LevelUp()
	Tree5:LevelUp()
	Tree5:LevelUp()
	Tree5:LevelUp()
	Tree5:LevelUp()


	-- Asteroid 3
	a = AddAsteroidWithAttribs(-2000,5000, 0.7,0.5,0.5)
	a.Owner = 4
	a.TreeCap = 5
	a:SetRadius(300)
	a.SendDistance = 3500
	a:Reveal(1)
	
	a:AddSeedlings(80)

	Tree1 = a:AddDysonTree()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree2 = a:AddDefenseTree()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree3 = a:AddDysonTree()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree4 = a:AddDefenseTree()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()


	-- Asteroid 4
	a = AddAsteroidWithAttribs(-1500,3000, 0.7,0.6,0.5)
	a.Owner = 0
	a.TreeCap = 5
	a:SetRadius(250)
	a.SendDistance = 2500
	a:Reveal(1)

	a:AddSuperSeedlings(30)

	--	a:AddTrees(0,4):LevelUp()
	Tree1 = a:AddDefenseTree()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree2 = a:AddDefenseTree()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree3 = a:AddDysonTree()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree4 = a:AddDefenseTree()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()

	-- Asteroid 5
	a = AddAsteroidWithAttribs(-1500,-2500, 0.7,0.3,0.6)
	a.Owner = 0
	a.TreeCap = 1
	a:SetRadius(100)
	a.SendDistance = 7500
	a:IsBarren()
	a:AddSeedlings(10)

	-- Asteroid 6
	a = AddAsteroidWithAttribs(3000,400, 0.7,0.6,0.5)
	a.Owner = 0
	a.TreeCap = 5
	a:SetRadius(250)
	a.SendDistance = 2500
	a:Reveal(1)

	a:AddSuperSeedlings(70)

	--	a:AddTrees(0,4):LevelUp()
	Tree1 = a:AddDysonTree()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree2 = a:AddDefenseTree()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree3 = a:AddDefenseTree()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()

	-- Asteroid 7
	a = AddAsteroidWithAttribs(1600,7000, 0.6,0.9,0.9)
	a.Owner = 3
	a.TreeCap = 5
	a:SetRadius(300)
	a.SendDistance = 1000
		
	--	a:AddTrees(0,4):LevelUp()
	Tree1 = a:AddDefenseTree()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree2 = a:AddDefenseTree()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree3 = a:AddDefenseTree()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree4 = a:AddDefenseTree()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree5 = a:AddDefenseTree()
	Tree5:LevelUp()
	Tree5:LevelUp()
	Tree5:LevelUp()
	Tree5:LevelUp()
	Tree5:LevelUp()
	Tree5:LevelUp()

	-- Asteroid 8
	a = AddAsteroidWithAttribs(2600,10000, 1.1,1.1,1.1)
	a.Owner = 1
	a.TreeCap = 7
	a:SetRadius(950)
	a.SendDistance = 8000

	a:AddSeedlings(90)

	--	a:AddTrees(0,4):LevelUp()
	Tree1 = a:AddDysonTree()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree1:LevelUp()
	Tree2 = a:AddDysonTree()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree2:LevelUp()
	Tree3 = a:AddDysonTree()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree3:LevelUp()
	Tree4 = a:AddDysonTree()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree4:LevelUp()
	Tree5 = a:AddDysonTree()
	Tree5:LevelUp()
	Tree5:LevelUp()
	Tree5:LevelUp()
	Tree5:LevelUp()
	Tree5:LevelUp()
	Tree5:LevelUp()
	Tree6 = a:AddDysonTree()
	Tree6:LevelUp()
	Tree6:LevelUp()
	Tree6:LevelUp()
	Tree6:LevelUp()
	Tree6:LevelUp()
	Tree6:LevelUp()
	Tree7 = a:AddDysonTree()
	Tree7:LevelUp()
	Tree7:LevelUp()
	Tree7:LevelUp()
	Tree7:LevelUp()
	Tree7:LevelUp()
	Tree7:LevelUp()
	a:Hide(1)


end



function LevelLogic()

	
	-- Greet the player
	Timer = GetGameTime() + 1


	while GetGameTime() < Timer do

		coroutine.yield()
	end

	Pause()
	MessageBox("Overcome the fields of thorns and you will be the master of these asteroids.")
	WaitDialog()
	Unpause()

	-- Add some enemies to Asteroid 1
	Timer = GetGameTime() + 120

	while GetGameTime() < Timer do

		coroutine.yield()
	end

	GetAsteroid(6):AddSuperSeedlings(30)


	while GameRunning() do	

		if GetEmpire(1):GetNumOwnedAsteroids() == 9 then
		
			Pause()
			MessageBox("Oh wow, you have found your own kind and they seem to be a good bunch of content Ones. Its all yours now.")
			WaitDialog()
			Unpause()
		
			Quit(true)
		end
	
		if GetEmpire(1):GetNumOwnedAsteroids() == 0 and GetEmpire(1).NumSeedlings == 0 then
		
			Pause()
			MessageBox("Oh dear, let's try it again, it'll work.")
			WaitDialog()
			Unpause()
		
			Quit(false)
		end

			
		coroutine.yield()
	end


end