function LevelSetup()

	-- Set Global Values
	Globals.G.Asteroids=(0)
	Globals.Asteroids.MinSendDistance=0.5
	Globals.Asteroids.MaxSendDistance=0.5
	Globals.G.EnemyFactionsMin=(1)
	Globals.G.EnemyFactionsMax=(1)
	Globals.G.GreysProbability=0
	Globals.AI.GraceTimer=(85)
	Globals.Structures.FlowerProbability=(0.025)
	Globals.Asteroids.MinCoreHealth=150
	Globals.Asteroids.MaxCoreHealth=300
	Globals.Asteroids.SpawnCap=100
	Globals.Asteroids.SeedlingCap=5000


	-- Asteroid 0 - starting asteroid
	a = AddAsteroidWithAttribs(0,0, 0.73,0.51,0.54)
	a.Owner = 1
	a.TreeCap = 5
	a:SetRadius(300)
	a.SendDistance = 1500
	a.Moveable = False

	s = a:AddDefenseTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	
	s = a:AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	f = s:AddFlower()
	a:AddSeedlings(50)


t = 1600

	

	for i=1,21 do 

	x = math.cos(t) * t
	y = math.sin(t) * t

	s = math.random(1,10) / 10
	e = math.random(1,10) / 10
	sp = math.random(1,10) / 10
	
	roidradius = 125 + ((i / 21) * (375 * ((s + e + sp) / 3)))
	
	a = AddAsteroidWithAttribs(x,y,s,e,sp)
	a.Owner = 2
	a.TreeCap = 4
	a:SetRadius(roidradius)


	a.Moveable = False

	
	
	t = t + 275
	
	end
	
	rr = 21
	GetAsteroid(rr):AddSeedlings(65)
	s = GetAsteroid(rr):AddDysonTree()
	s.Enhanced = true
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = GetAsteroid(rr):AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = GetAsteroid(rr):AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = GetAsteroid(rr):AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()

	
	rr = 20
	GetAsteroid(rr):AddSeedlings(65)
	s = GetAsteroid(rr):AddDysonTree()
	s.Enhanced = true
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = GetAsteroid(rr):AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = GetAsteroid(rr):AddDysonTree()	
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = GetAsteroid(rr):AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	
	
	rr = 19
	GetAsteroid(rr):AddSeedlings(65)
	s = GetAsteroid(rr):AddDysonTree()
	s.Enhanced = true
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = GetAsteroid(rr):AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = GetAsteroid(rr):AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = GetAsteroid(rr):AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	
	rr = 18
	GetAsteroid(rr):AddSeedlings(65)
	s = GetAsteroid(rr):AddDysonTree()
	s.Enhanced = true
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = GetAsteroid(rr):AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = GetAsteroid(rr):AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	s = GetAsteroid(rr):AddDysonTree()
	s:LevelUp()
	s:LevelUp()
	s:LevelUp()
	
	
	-- lots of variables
	gamelost = 0
	latch = 0
	gatherspot = 21
	target = 0
	attackpoint = 0
		
	frontline0 = GetAsteroid(0)
	frontline1 = GetAsteroid(0)
	frontline2 = GetAsteroid(0)
	frontline3 = GetAsteroid(0)
	frontline4 = GetAsteroid(0)
	frontline5 = GetAsteroid(0)
	frontline7 = GetAsteroid(0)
	frontline8 = GetAsteroid(0)
	frontline9 = GetAsteroid(0)
	frontline10 = GetAsteroid(0)
	frontline11 = GetAsteroid(0)
	frontline12 = GetAsteroid(0)
	frontline13 = GetAsteroid(0)
	frontline14 = GetAsteroid(0)
	frontline15 = GetAsteroid(0)
	frontline16 = GetAsteroid(0)
	frontline17 = GetAsteroid(0)

	
	

end



function LevelLogic()

	SetBackdropColour(0,0,0)


	GetAI(2).Cowardice = 0.05
	GetAI(2).MinExpansionForce = 10
	GetAI(2).BattleSavvy = 0.1
	GetAI(2).ReinforcementGreed = 0.9
	GetAI(2).GreedyExpansion = 0.9
	GetAI(2).AidEnthusiasm = 0.9
	GetAI(2).ExpandBlind = 0.9
	GetAI(2).ExpandToValuableAsteroidChance = 0.1
	
	



	gcolourcurrent = 0

	
	Timer = GetGameTime() + 15
	
	while GetGameTime() < Timer do
		coroutine.yield()
	end
	
	Pause()
	MessageBox("Daybreak.                                                     Soon you will come to fear the night.  Lose Fluffy Land and the game is over.  Conquer the sector to win!")
	WaitDialog()
	Unpause()
	
	happywintime = 0
	
	
while GameRunning() do

	
	
				if happywintime == 0 and GetEmpire(2):GetNumOwnedAsteroids() == 0 then 
			Pause()
			MessageBox("You have conquered the sector!  :D")
			WaitDialog()
			Unpause()
			happywintime = 1
			
			Quit(true)
		end
	
	

		
	
		-- this is the code for the day/night cycle
		timetemp = GetGameTime() / 30
		

		gcolour = 175 * ((math.sin(timetemp) / 0.5) + 0.5)


		
		if gcolourcurrent < gcolour then
		
			gcolourcurrent = gcolourcurrent + 1
			
		end
		
		if gcolourcurrent > gcolour then
			
			gcolourcurrent = gcolourcurrent - 1
			
		end


		rcolour = gcolourcurrent * 1.45
		bcolour = 0
		if gcolourcurrent > 127 then
			bcolour = (gcolourcurrent * 1.45) - 127
		end
		
		gcolourcurrent = gcolourcurrent - 30
		
		
		SetBackdropColour(rcolour,gcolourcurrent,bcolour)

		gcolourcurrent = gcolourcurrent + 30
		
		
		
		-- losing condition
		if gamelost == 1 then
			Pause()
			MessageBox("You have lost.  :<  Don't give up, it's not that hard!")
			WaitDialog()
			Unpause()
			Quit(false)
			gamelost = 2
		end
		
		
		aitest = GetAI(2):GetRandomAsteroid()
		if aitest:GetNumTrees() < 2 and aitest:GetNumSeedlings(2) > 9 then
			aitest:PlantDysonTree(2)
		end

		if aitest:GetNumSeedlings(2) > 1000 then
			unlucky = GetEmpire(1):GetRandomAsteroid()
			aitest:SendSeedlingsToTarget(2,200,unlucky)
		end
		
		
		-- frontline attacks
		
		
		if latch == 0 and gcolourcurrent < 5 and GetGameTime() > 300 then
			latch = 1
			for ii=1,21 do
				if GetAI(2):OwnsAsteroidID(ii) and GetAsteroid(ii):GetNumSeedlings(2) > 50 then
					if GetAsteroid(ii):GetNumSeedlings(2) > 50 + GetAsteroid(target):GetNumSeedlings(1) then
						GetAsteroid(ii):SendSeedlingsToTarget(2,5000,frontline0)
					elseif GetAsteroid(ii):GetNumSeedlings(2) > (GetAsteroid(target):GetNumSeedlings(1) - (GetAsteroid(ii):GetNumSeedlings(1) * 0.7)) then
						frontlinetemp = frontline0
						frontline0 = GetEmpire(1):GetRandomAsteroid()
						GetAsteroid(ii):SendSeedlingsToTarget(2,5000,frontline0)
						frontline0 = frontlinetemp
					end
				
				end
			end
		--	MessageBox("Sending seeds")
		end

		
		
		-- gathering up on the nearest roid
		
		if target < 13 then
		gatherspot = target + 4
		elseif target > 12 then
		gatherspot = target - 4
		end
		

		
		if latch == 1 and gcolourcurrent > 10 and GetGameTime() > 300 then
			latch = 0
			GetAsteroid(gatherspot):SetGraceTime(100)
			for ii=1,21 do
				if GetAI(2):OwnsAsteroidID(ii) and GetAsteroid(ii):GetNumSeedlings(2) > 10 and GetAsteroid(ii):GetNumTrees() > 1 and GetAI(2):OwnsAsteroidID(gatherspot) then
					GetAsteroid(ii):SendSeedlingsToTarget(2,2000,GetAsteroid(gatherspot))
				end
			end
		end
		

		
		if frontline0 == GetAsteroid(0) then
			target = 0
		elseif frontline0 == GetAsteroid(1) then
			target = 1
		elseif frontline0 == GetAsteroid(2) then
			target = 2
		elseif frontline0 == GetAsteroid(3) then
			target = 3
		elseif frontline0 == GetAsteroid(4) then
			target = 4
		elseif frontline0 == GetAsteroid(5) then
			target = 5
		elseif frontline0 == GetAsteroid(6) then
			target = 6
		elseif frontline0 == GetAsteroid(7) then
			target = 7
		elseif frontline0 == GetAsteroid(8) then
			target = 8
		elseif frontline0 == GetAsteroid(9) then
			target = 9
		elseif frontline0 == GetAsteroid(10) then
			target = 10
		elseif frontline0 == GetAsteroid(11) then
			target = 11
		elseif frontline0 == GetAsteroid(12) then
			target = 12
		elseif frontline0 == GetAsteroid(13) then
			target = 13
		elseif frontline0 == GetAsteroid(14) then
			target = 14
		elseif frontline0 == GetAsteroid(15) then
			target = 15
		elseif frontline0 == GetAsteroid(16) then
			target = 16
		elseif frontline0 == GetAsteroid(17) then
			target = 17
		elseif frontline0 == GetAsteroid(18) then
			target = 18
		elseif frontline0 == GetAsteroid(19) then
			target = 19
		elseif frontline0 == GetAsteroid(20) then
			target = 20
		elseif frontline0 == GetAsteroid(21) then
			target = 21
		end
		
		
		

		
		
		if attackpoint > 0 then
		
		frontline16 = frontline15
		frontline15 = frontline14
		frontline14 = frontline13
		frontline13 = frontline12
		frontline12 = frontline11
		frontline11 = frontline10
		frontline10 = frontline9
		frontline9 = frontline8
		frontline8 = frontline7
		frontline7 = frontline6
		frontline6 = frontline5
		frontline5 = frontline4
		frontline4 = frontline3
		frontline3 = frontline2
		frontline2 = frontline1
		frontline1 = frontline0
		
			
			frontline0 = GetAsteroid(attackpoint)
			
			
			
		attackpoint = 0
		end
		
		
		

		
		
		
	coroutine.yield()
end


end


function OnAsteroidTaken(id,owner)


-- losing condition
	if id == 0 and owner == 2 then
		gamelost = 1
		return
	end
	

-- frontline detection


		if id == target and owner == 2 then
		frontline0 = frontline1
		frontline1 = frontline2
		frontline2 = frontline3
		frontline3 = frontline4
		frontline4 = frontline5
		frontline5 = frontline6
		frontline6 = frontline7
		frontline7 = frontline8
		frontline8 = frontline9
		frontline9 = frontline10
		frontline10 = frontline11
		frontline11 = frontline12
		frontline12 = frontline13
		frontline13 = frontline14
		frontline14 = frontline15
		frontline15 = frontline16
		return
	end


		if id == 1 and owner == 1 then
		attackpoint = 1
		return
	end

	if id == 2 and owner == 1 then
		attackpoint = 2
		return
	end
	
		if id == 3 and owner == 1 then
		attackpoint = 3
		return
	end
	
		if id == 4 and owner == 1 then
		attackpoint = 4
		return
	end

		if id == 5 and owner == 1 then
		attackpoint = 5
		return
	end
	
		if id == 6 and owner == 1 then
		attackpoint = 6
		return
	end
	
		if id == 7 and owner == 1 then
		attackpoint = 7
		return
	end
	
		if id == 8 and owner == 1 then
		attackpoint = 8
		return
	end
	
		if id == 9 and owner == 1 then
		attackpoint = 9
		return
	end
	
		if id == 10 and owner == 1 then
		attackpoint = 10
		return
	end
	
		if id == 11 and owner == 1 then
		attackpoint = 11
		return
	end
	
		if id == 12 and owner == 1 then
		attackpoint = 12
		return
	end
	
		if id == 13 and owner == 1 then
		attackpoint = 13
		return
	end
	
		if id == 14 and owner == 1 then
		attackpoint = 14
		return
	end
	
		if id == 15 and owner == 1 then
		attackpoint = 15
		return
	end
	
		if id == 16 and owner == 1 then
		attackpoint = 16
		return
	end
	
		if id == 17 and owner == 1 then
		attackpoint = 17
		return
	end
	
		if id == 18 and owner == 1 then
		attackpoint = 18
		return
	end
	
		if id == 19 and owner == 1 then
		attackpoint = 19
		return
	end
	
		if id == 20 and owner == 1 then
		attackpoint = 20
		return
	end
	
		if id == 21 and owner == 1 then
		attackpoint = 21
		return
	end
	
end