function AIInit()
	-- *** INFECTED AI V2 INIT ***
	-- BETA VERSION 2.3
	-- Author: ANNIKK.EXE [at] GMAIL [dot] COM
	
	
	Globals.AI.GraceTimer=(99999)
	
	-- Number of times the engine is run per While loop:
	numberofiterations = 0
	-- Set to 0 for very large maps. (50 asteroids+)
	-- Set to 2-4 for small maps for quicker AI response.
	
	metric = {}
	currentowner = {}
	
	for i = 0,200 do
		metric[i] = 500
	end
	

	-- *** END INFECTED AI INIT ***
end


function GravityInit()
	-- ** Initialise Gravity Variables.
	
	gravinit = false
	
	AccelerationX = {}
	AccelerationY = {}
	MomentumX = {}
	MomentumY = {}
	density = {}
	CoordX = {}
	CoordY = {}
	roidradius = {}
	str = {}
	ene = {}
	spe = {}
	collision = {}
	collisiontimer = {}
	Timer = 0
	collidedbefore = {}
	oldCoordX = {}
	oldCoordY = {}
	
	-- **
	
	-- ** G is the gravitational constant.  Affects how powerful gravity is in the entire map.  Change this as you like. **
	
	G = 10
	
	-- **

	-- ****************************************
	-- **********Asteroid Creation*************
	-- ****************************************

	
	
	roid = -1
	-- ***
	-- 1.  THE BELOW ASTEROIDS HAVE A GRAVITY WELL BUT DO NOT THEMSELVES MOVE
	-- ***
	
	-- ** counter for gravity behaviour divisions, do not remove **
	wellonlythreshold = roid + 1
	-- **
	
	-- ***
	-- 2.  THE BELOW ASTEROIDS HAVE A GRAVITY WELL, AND MOVE
	-- ***

	
	-- Asteroid 0 - A Sun
	-- gravity variables
	roid = 0
	AccelerationX[roid] = 0
	AccelerationY[roid] = 0
	MomentumX[roid] = 0
	MomentumY[roid] = 0
	density[roid] = 0.2
	CoordX[roid] = 0
	CoordY[roid] = 0
	oldCoordX[roid] = 0
	oldCoordY[roid] = 0
	roidradius[roid] = 400
	
	-- Creation
	a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],0.5,0.5,1)
	a.Owner = 1
	a.TreeCap = 6
	a:SetRadius(roidradius[roid])
	a:Reveal(1)
	a.Moveable = False
	a:AddSeedlings(30,1,0.5,0.5,0.2)
	
	
	
	-- Asteroid 1 - A moving asteroid
	-- gravity variables

	name = 0

	
	
	for makeroids = 1,17 do
		roid = makeroids
		AccelerationX[roid] = 0
		AccelerationY[roid] = 0
		CoordX[roid] = math.random(-15000,15000)
		CoordY[roid] = math.random(-15000,15000)
		roidradius[roid] = math.random(300,800)
		
		for overlapcheck = 1,makeroids do
			if GetAsteroid(roid) ~= GetAsteroid(overlapcheck) then
				
				xcheck = CoordX[roid] - CoordX[overlapcheck]
				ycheck = CoordY[roid] - CoordY[overlapcheck]
				radiitotal = roidradius[roid] + roidradius[overlapcheck]
				
				if math.sqrt(xcheck^2) - radiitotal < 5 then
					CoordX[roid] = math.random(-15000,15000)
					CoordY[roid] = math.random(-15000,15000)
		
				end
			end
		end
		
		oldCoordX[roid] = CoordX[roid]
		oldCoordY[roid] = CoordY[roid]

	
		if CoordX[roid] < 0 then 
	
			MomentumY[roid] = 0 --math.random(1,5)
	
		else
	
			MomentumY[roid] = 0 --math.random(-5,1)
		
		end
	
		if CoordY[roid] < 0 then
	
			MomentumX[roid] = 0 --math.random(-5,1)
	
		else
	
			MomentumX[roid] = 0 --math.random(1,5)
	
		end
	
	
	
	
	
		density[roid] = 0.1
		str[roid] = (math.random(1,10) / 10) * (roidradius[roid] / 800)
		ene[roid] = (math.random(1,10) / 10) * (roidradius[roid] / 800)
		spe[roid] = (math.random(1,10) / 10) * (roidradius[roid] / 800)
	
		-- Creation
		a = AddAsteroidWithAttribs(CoordX[roid],CoordY[roid],str[roid],ene[roid],spe[roid])
		a.Owner = 0
		a.TreeCap = 4
		a:SetRadius(roidradius[roid])
		a:Reveal(1)
		a.Moveable = True
		
		
	
		
	
	end
	
	-- ** counter for gravity behaviour divisions, do not remove **
	gravroidsthreshold = roid
	-- **
	
	-- 3.  THE BELOW ASTEROIDS DO NOT MOVE AND DO NOT HAVE A GRAVITY WELL
	
	-- spacer asteroid, used to make sure the level is big enough for asteroids to wander about on long, eliptical orbits.  Change to taste.
	a = AddAsteroidWithAttribs(40000,5000,0.5,0.5,0.5)
	a.Owner = 0
	a.TreeCap = 4
	a:SetRadius(1)
	a.Moveable = False

	roidnumber = roid
	
	GetAsteroid(0).Name = "Fluffy"
	GetAsteroid(1).Name = "Alex"
	GetAsteroid(2).Name = "Rudolf"
	GetAsteroid(3).Name = "Pilchard"
	GetAsteroid(4).Name = "AWS"
	GetAsteroid(5).Name = "Bonobo"
	GetAsteroid(6).Name = "Sniped"
	GetAsteroid(7).Name = "Vanger"
	GetAsteroid(8).Name = "W4TC"
	GetAsteroid(9).Name = "Ariest"
	GetAsteroid(10).Name = "Wogan"
	GetAsteroid(11).Name = "Killbilly"
	GetAsteroid(12).Name = "Mihhaelo"
	
	if math.random(1,2) == 1 then
		GetAsteroid(13).Name = "Megagoten"
	else
		GetAsteroid(13).Name = "Threephi"
	end
	
	if math.random(1,2) == 1 then
		GetAsteroid(14).Name = "Njursten"
	else
		GetAsteroid(14).Name = "Ponto"
	end
	
	if math.random(1,2) == 1 then
		GetAsteroid(15).Name = "Torchfire"
	else
		GetAsteroid(15).Name = "Pigpenguin"
	end
	
	if math.random(1,2) == 1 then
		GetAsteroid(16).Name = "Dragoonreas"
	else
		GetAsteroid(16).Name = "Widget"
	end
	
	randomname = math.random(1,100)
	if randomname < 10 then
		GetAsteroid(17).Name = "Valve Sucks"
	elseif randomname < 20 then
		GetAsteroid(17).Name = "Gerald Kwirk"
	elseif randomname < 30 then
		GetAsteroid(17).Name = "annikk.exe"
	else
		GetAsteroid(17).Name = "It's a trap!"
	end
	
	-- END ASTEROID CREATION
end


function ParallaxInit()
	-- *** PARALAX SCROLLING ENGINE INIT **
	-- *** FIRST DRAFT - STARFIELD DESIGN ***
	linex1 = {}
	liney1 = {}
	linex1mod = {}
	liney1mod = {}
	red = {}
	green = {}
	blue = {}
	threshold = {}
	zdepth = {}
	

	-- *** START OF USER-CHANGEABLE PARALLAX VARIABLES
	
	numberofstars = 800
	numberoflayers = 100
	widthofstarfield = 50000
	heightofstarfield = 50000
	starsize = 230
	alpha = 1
	stoprenderingbelow = 0.2
	thresholdsetting = 1.019
	startthresh = 0.3
	
	
	for lnumber = 1,numberoflayers do
		red[lnumber] = math.random(20,100) / 100
		green[lnumber] = math.random(20,100) / 100
		blue[lnumber] = math.random(20,100) / 100
		
	
	
		-- Fadeout threshold - The smaller the number, the further away you can zoom and still see the given layer of stars.
--		threshold[lnumber] = startthresh
		
--		startthresh = startthresh / thresholdsetting
		
		-- subtract 0.007 from the game's camera scale to get the point at which threshold makes it visible
		
		if lnumber < 10 then
			threshold[lnumber] = 0.085
		elseif lnumber < 20 then
			threshold[lnumber] = 0.080
		elseif lnumber < 30 then
			threshold[lnumber] = 0.075
		elseif lnumber < 40 then
			threshold[lnumber] = 0.070
		elseif lnumber < 50 then
			threshold[lnumber] = 0.065
		elseif lnumber < 60 then
			threshold[lnumber] = 0.060
		elseif lnumber < 70 then
			threshold[lnumber] = 0.054
		elseif lnumber < 80 then
			threshold[lnumber] = 0.049
		elseif lnumber < 90 then
			threshold[lnumber] = 0.044
		elseif lnumber < 95 then
			threshold[lnumber] = 0.038
		elseif lnumber < 97 then
			threshold[lnumber] = 0.025
		else
			threshold[lnumber] = 0.002
		end
		
		
		-- z depth - how far away does each layer look?  The closer to 1, the further away it looks.  Don't use values that are less than 1 or stars will move backwards!
		
		zdepth[numberoflayers - lnumber + 1] = 1 + (5 * (1 / lnumber))
	end
	
	-- far background.
--[[	threshold[1] = 0.001
	threshold[2] = 0.5
	threshold[3] = 0.108
	threshold[4] = 0.5
	threshold[5] = 0.073
	threshold[6] = 0.5
	threshold[7] = 0.094
	threshold[8] = 0.102
	threshold[9] = 0.5
	threshold[10] = 0.5
	threshold[11] = 0.056
	threshold[12] = 0.5
	threshold[13] = 0.101
	threshold[14] = 0.081
	threshold[15] = 0.5
	threshold[16] = 0.078
	threshold[17] = 0.5
	threshold[18] = 0.034
	threshold[19] = 0.5
	threshold[20] = 0.068
	threshold[21] = 0.5
	threshold[22] = 0.5
	threshold[23] = 0.5
	threshold[24] = 0.095
	threshold[25] = 0.088
	threshold[26] = 0.5
	threshold[27] = 0.049
	threshold[28] = 0.082
	threshold[29] = 0.5
	threshold[30] = 0.5
	threshold[31] = 0.047
	threshold[32] = 0.097
	threshold[33] = 0.107
	threshold[34] = 0.082
	threshold[35] = 0.5
	threshold[36] = 0.5
	threshold[37] = 0.077
	threshold[38] = 0.5
	threshold[39] = 0.087
	threshold[40] = 0.030
	threshold[41] = 0.103
	threshold[42] = 0.045
	threshold[43] = 0.5
	threshold[44] = 0.079
	threshold[45] = 0.5
	threshold[46] = 0.053
	threshold[47] = 0.5
	threshold[48] = 0.080
	threshold[49] = 0.5
	threshold[50] = 0.048
	threshold[51] = 0.5
	threshold[52] = 0.083
	threshold[53] = 0.096
	threshold[54] = 0.075
	threshold[55] = 0.106
	threshold[56] = 0.088
	threshold[57] = 0.044
	threshold[58] = 0.5
	threshold[59] = 0.038
	threshold[60] = 0.104
	threshold[61] = 0.5
	threshold[62] = 0.086
	threshold[63] = 0.5
	threshold[64] = 0.5
	threshold[65] = 0.065
	threshold[66] = 0.100
	threshold[67] = 0.5
	threshold[68] = 0.089
	threshold[69] = 0.5
	threshold[70] = 0.5
	threshold[71] = 0.090
	threshold[72] = 0.5
	threshold[73] = 0.076
	threshold[74] = 0.5
	threshold[75] = 0.093
	threshold[76] = 0.099
	threshold[77] = 0.078
	threshold[78] = 0.001
	threshold[79] = 0.5
	threshold[80] = 0.043
	threshold[81] = 0.5
	threshold[82] = 0.5
	threshold[83] = 0.050
	threshold[84] = 0.105
	threshold[85] = 0.039
	threshold[86] = 0.059
	threshold[87] = 0.5
	threshold[88] = 0.084
	threshold[89] = 0.098
	threshold[90] = 0.092
	threshold[91] = 0.5
	threshold[92] = 0.085
	threshold[93] = 0.042
	threshold[94] = 0.5
	threshold[95] = 0.091
	threshold[96] = 0.062
	threshold[97] = 0.072
	threshold[98] = 0.074
	threshold[99] = 0.071
	threshold[100] = 0.046--]]
	-- far foreground
	
	
	
	
	-- *** END OF USER-CHANGEABLE PARALLAX VARIABLES
	
	starsinlayer = numberofstars / numberoflayers

	for i = 0,numberofstars do
		-- generate stars
		
		linex1mod[i] = math.random(0,widthofstarfield) - (widthofstarfield / 2)
		liney1mod[i] = math.random(0,heightofstarfield) - (heightofstarfield / 2)
	end
	
	-- auto-detect number of asteroids, up to a maximum of "maxasteroids".  Ignore any asteroids with radius smaller than "radiusignorethreshold".
	-- this is needed so that stars are hidden when they are on top of an asteroid, so it looks like they went behind the asteroid.
	
	maxasteroids = 200
	radiusignorethreshold = 10
	numberofasteroids = -1
	
	for i = 0, maxasteroids do
		if GetAsteroid(i) ~= nil then
			if GetAsteroid(i).radius > radiusignorethreshold then
				numberofasteroids = numberofasteroids + 1
			end
		end
	end
	-- now the variable called "numberofasteroids" accurately represents the number of playable asteroids on the field.
	-- *** END PARALAX SCROLLING ENGINE INIT **
end


function InfectedAIEngine()
	-- *** INFECTED AI V2 ***
	-- BETA VERSION 2.3
	-- Author: ANNIKK.EXE [at] GMAIL [dot] COM
	numberofasteroids = -1
	local neighbours = {}

	
	for i = 0, 200 do
		if GetAsteroid(i) ~= nil then
			if GetAsteroid(i).radius > 10 then
				numberofasteroids = numberofasteroids + 1
			end
		end
	end

	-- now the variable called "numberofasteroids" accurately represents the number of playable asteroids on the field.


	for iterations = 0,numberofiterations do
	
	
		-- Select an asteroid for checking.
		checkedroid = GetAsteroid(math.random(0,numberofasteroids))

		
		-- Record the current asteroid owner
		
		changedowner = false
		
		if currentowner[checkedroid.id] ~= nil then
			if currentowner[checkedroid.id] ~= checkedroid.owner then
				currentowner[checkedroid.id] = checkedroid.owner
				changedowner = true
			end
		else
			currentowner[checkedroid.id] = checkedroid.owner
		end

		
		tree = nil
		flower = nil
	
		-- flower check !
		tree = checkedroid:GetRandomDysonTree()
		
		if tree ~= nil then
			flower = tree:GetSuperSeedling()
		end
		
		if checkedroid.owner > 1 and flower ~= nil then
			flower:Pluck()
		end
		
		flower = checkedroid:GetFlower(checkedroid.owner)
		
		if checkedroid.owner > 1 and flower ~= nil then
			flower:PlantOnRandomDysonTree()
		end

	
	
		-- calculate which asteroids are a neighbour to checkedroid
		
		numberofneighbours = -1

		for i = 0,numberofasteroids do
			
			length = GetAsteroid(i).position.x - checkedroid.position.x
			height = GetAsteroid(i).position.y - checkedroid.position.y
			
			distancetoroid = math.sqrt((length * length) + (height * height))
			distancetoroid = distancetoroid - GetAsteroid(i).Radius
			
			if distancetoroid < checkedroid.SendDistance then
				-- this asteroid is in range.  Add it to the neighbours list, and increment the neighbour count by one.  ALSO ADDS SELF AS NEIGHBOUR!  But we trap for this in the Metric Update section.
				numberofneighbours = numberofneighbours + 1
				neighbours[numberofneighbours] = GetAsteroid(i)
			end
		end
	
		
	
	
		-- Metric update
	
		-- did we update from our own status?
		
		updated = false
		
		-- are we under attack?  if so set metric 0
		
		
		if checkedroid.owner ~= 1 and checkedroid.owner ~= 0 then
			
			
			if (checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(checkedroid.owner)) > (checkedroid:GetNumTrees() * 5) or checkedroid:GetNumMines(1) > 0 then
				
				
				-- ok well we own this asteroid, and there are more enemy seeds here than our seeds (or there's a player mine here).  Now, we DO have at least 1 tree worth defending here, right?
				if checkedroid:GetNumTrees() > 0 then
					-- ok, we're under attack!  METRIC 0!
					metric[checkedroid.ID] = 0
					updated = true
					
					
				end
			end
		end
		
		
		
		-- are we maxed on trees?  if not, set metric 100
		
		-- (make sure we don't run this if we are under attack!)
		if updated == false then

			if checkedroid:GetNumTrees() < checkedroid.TreeCap then
				-- we don't have max trees here yet.  Metric 100!
				metric[checkedroid.ID] = 100
				updated = true
			end
			
		end
		-- Not under attack, maxed on trees, and ready to contribute to the empire.
		-- Check the status of our neighbours first before trying to become a gather point.
		
		
		-- only run this part of the code if we didn't get our metric from our own status
		if updated == false then
		
		
		
	

		
			-- are we a suitable gather point?
			
			enemydetected = false
			frienddetected = false
			gatherpointdetected = false
			lowermetricsnearby = false
		
			for i = 0, numberofneighbours do
			
				-- check that we're not examining ourself.
				if neighbours[i] ~= checkedroid then
		
					if neighbours[i].owner == checkedroid.owner then
						-- this asteroid is friendly to us
						frienddetected = true
					end
				
					if neighbours[i].owner ~= checkedroid.owner and neighbours[i].owner ~= 0 and neighbours[i]:GetNumTrees() > 0 then
						-- this asteroid doesn't belong to us or player 0, and has at least 1 tree.  It must be an enemy roid.
						enemydetected = true
					end
					
					
					numberofenemies = neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)
				
					if neighbours[i].owner ~= checkedroid.owner and neighbours[i]:GetNumTrees() == 0 and numberofenemies > 0 then
						-- this asteroid doesn't belong to us, has no trees on it, but has enemy seedlings on it.  Treat it as enemy.
						enemydetected = true
					end
		
					
					if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].ID] == 200 then
						-- this asteroid is friendly to us, and is a gather point.
						gatherpointdetected = true
					end
				
					if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].id] ~= 500 then
						-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
						lowermetricsnearby = true
					end
				
				end
			
			end
			
			
			if enemydetected == true and frienddetected == true and gatherpointdetected == false and lowermetricsnearby == false then
				-- the conditions are right for me to become a gather point.
				metric[checkedroid.id] = 200
			elseif changedowner == true then
				-- the asteroid just became mine.  insta-gather point please!
				metric[checkedroid.id] = 200
			end
			

			
			-- Find the lowest metric among my neighbours
			lowestmetric = metric[checkedroid.ID]
			
			
			for i = 0, numberofneighbours do
				
				-- check that we're not examining ourself.
				if neighbours[i].id ~= checkedroid.id then
			
					if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
						-- this asteroid belongs to our empire, or it doesn't belong to anyone (and we should therefore follow its metrics)
						
						-- is this neighbour's metric less than mine?  (also, have we just taken this asteroid..?)
						if metric[neighbours[i].ID] < lowestmetric and changedowner == false then
							-- yes it's lower.
							lowestmetric = metric[neighbours[i].ID]
						end
				
					
					end
				
				end
			end
		
			
		
			-- now we've established what the lowest metric is.  If it's lower than ours, set ours to that +1.  If the lowest metric of a neighbour is the same as our metric, increase ours by 1.
			-- UNLESS we are a gather point
			if metric[checkedroid.ID] > lowestmetric and metric[checkedroid.ID] ~= 200 and metric[checkedroid.ID] ~= 100 then
				metric[checkedroid.ID] = lowestmetric + 5
			end
			
			if metric[checkedroid.ID] == lowestmetric and metric[checkedroid.ID] ~= 200 and metric[checkedroid.ID] ~= 100 then
				-- if my metric is the same as the lowest metric of my neighbours, i must be 1 step further away than they are.
				metric[checkedroid.ID] = metric[checkedroid.ID] + 5
			end
			
			-- check for errors, reset metric if necessary
			
			if metric[checkedroid.id] > 500 then
				metric[checkedroid.id] = 200
			end
			
			if metric[checkedroid.ID] > 0 and metric[checkedroid.ID] < 99 then
				stillinneed = false
				
				for i = 0,numberofasteroids do
					if GetAsteroid(i).Owner == checkedroid.Owner and metric[i] == 0 then
						stillinneed = true
					end
				end
				
				if stillinneed == false then
					for i = 0,numberofasteroids do
						if GetAsteroid(i).owner == checkedroid.owner and metric[i] > 0 and metric[i] < 99 then
							metric[i] = 500
						end
					end
				end
			
			end
			
			if metric[checkedroid.ID] > 100 and metric[checkedroid.ID] < 199 then
				stillinneed = false
				for i = 0,numberofasteroids do
					if GetAsteroid(i).Owner == checkedroid.Owner or GetAsteroid(i).owner == 0 then
						if metric[i] == 100 then
							stillinneed = true
						end
					end
				end
				
				if stillinneed == false then
					for i = 0,numberofasteroids do
						if GetAsteroid(i).owner == checkedroid.owner and metric[i] > 100 and metric[i] < 199 then
							metric[i] = 500
						end
					end
				end
			end
			
			if metric[checkedroid.ID] > 200 and metric[checkedroid.ID] < 299 then
				stillinneed = false
				for i = 0,numberofasteroids do
					if GetAsteroid(i).Owner == checkedroid.Owner and metric[i] == 200 then
						stillinneed = true
					end
				end
				
				if stillinneed == false then
					for i = 0,numberofasteroids do
						if GetAsteroid(i).owner == checkedroid.owner and metric[i] > 200 and metric[i] < 299 then
							metric[i] = 500
						end
					end
				end
			end
			
			
			
			
			
			
		end
	
	
	
		-- Now to check that if we have metric 0, 100 or 200, we still require that status.
		
		if metric[checkedroid.id] == 0 then
			-- ok.  Am I REALLY still under attack?
			if checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(checkedroid.owner) > 1 or checkedroid:GetNumMines(1) > 0 then
				-- the enemy outnumber us, or there's a player mine here.  Yes, we're really under attack...
			else
				-- we're not really under attack anymore.  lets reset the metric.
				for i = 0, numberofasteroids do
					if GetAsteroid(i).owner == checkedroid.owner then
						metric[i] = 500
					end
				
				end
				
				metric[checkedroid.id] = 200
				
			end
		end
		
		if metric[checkedroid.id] == 100 then
			-- ok.  Am I REALLY still under construction?
			if checkedroid:GetNumTrees() < checkedroid.TreeCap then
				-- we do indeed have less trees than the treecap, so we still need seeds.
			else
				-- we're not really under construction anymore.  lets reset the metric.
				metric[checkedroid.id] = 200
			end
		end
		
		
		
		enemydetected = false
		frienddetected = false
		gatherpointdetected = false	
		lowermetricsnearby = false
		
		

		-- ok.  Am I REALLY still a suitable gather point?
		for i = 0, numberofneighbours do
			-- check that we're not examining ourself.
			if metric[checkedroid.ID] == 200 and neighbours[i].ID ~= checkedroid.id and changedowner == false then
				if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
					-- this asteroid is friendly or neutral to us
					frienddetected = true
				end
			
				if neighbours[i].owner ~= checkedroid.owner and neighbours[i].owner ~= 0 and neighbours[i]:GetNumTrees() > 0 then
					-- this asteroid doesn't belong to us or player 0, and has at least 1 tree.  It must be an enemy roid.
					enemydetected = true
				end
				
				numberofenemies = neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)
				
				if neighbours[i].owner ~= checkedroid.owner and neighbours[i]:GetNumTrees() == 0 and numberofenemies > 9 then
					-- this asteroid doesn't belong to us, has no trees on it, but has enemy seedlings on it.  Treat it as enemy.
					enemydetected = true
				end
				
				if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].ID] == 200 then
					-- this asteroid is friendly to us, and is a gather point.
					gatherpointdetected = true
				end
				
				if neighbours[i].owner == checkedroid.owner and metric[neighbours[i].id] < 200 then
					-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
					lowermetricsnearby = true
				end			
				if neighbours[i].owner == 0 and metric[neighbours[i].id] < 200 then
					-- uh-oh, there's an asteroid nearby with a metric lower than 200.  There are Lower Metrics Nearby!
					lowermetricsnearby = true
				end	
			end
		
		
		end
		
		
		if metric[checkedroid.id] == 200 and changedowner == false then
			
			if enemydetected == true and gatherpointdetected == false and lowermetricsnearby == false then
				-- the conditions are right for me to continue as a gather point.

			else
				-- the conditions are no longer right.  Best to reset the metric.
				metric[checkedroid.id] = 500
			end
			

			
		end
	
		if frienddetected == false and enemydetected == true and checkedroid:GetNumTrees() == checkedroid.TreeCap then
			-- we're an orphan with max trees!  lets become a gather point.
			metric[checkedroid.id] = 200
		end
	
	
	
	
		-- Actions
		
		-- There are 3 different action types.  We must make sure not to use any actions for players 0 and 1!
		-- 1.  Plant trees
		
		-- trap for player 0, exclude player 1
		if checkedroid.owner == 0 or checkedroid.owner > 1 then
			-- so plant one :>
			for i = 2,10 do		
				
				if metric[checkedroid.id] == 100 and (checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(i)) < 5 and checkedroid:GetNumSeedlings(i) > 9 then
					-- this asteroid isn't owned by greys or player, the enemy only has a bit of seedlings here
					-- its metric is 100
					-- and it has enough seedlings belonging to the asteroid's empire to plant a tree
					a = checkedroid:PlantDysonTree(i)
				end
			end
		end
		
		
		
		-- 2.  Send seedlings to the next lowest metric
		
		if metric[checkedroid.id] ~= 0 and metric[checkedroid.id] ~= 100 and metric[checkedroid.id] ~= 500 and checkedroid.owner > 1 then
		
			-- we're not under attack or construction.
			numberofdestinations = 0
			
			for i = 0,numberofneighbours do
				if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
					-- this neighbour is one of our asteroids, or it's a blank asteroid

					if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
						if metric[neighbours[i].ID] < metric[checkedroid.ID] then
							-- we've found a friendly neighbour with a metric lower than ours!
							-- add it to the destinations list
							numberofdestinations = numberofdestinations + 1
						end
					end


	
				end
			end
			
			if numberofdestinations > 0 then
			
				-- we've found some destinations to send seeds to.  Lets send some.
				numberofseedsleft = checkedroid:GetNumSeedlings(checkedroid.owner) - (checkedroid:GetNumSeedlings() - checkedroid:GetNumSeedlings(checkedroid.owner))
				numberperdestination = numberofseedsleft / numberofdestinations
				
				for i = 0,numberofneighbours do
					if neighbours[i] ~= checkedroid then
						if neighbours[i].owner == checkedroid.owner or neighbours[i].owner == 0 then
							if metric[neighbours[i].ID] < metric[checkedroid.ID] then
								-- this destination has less than our metric.  This is one of the valid destinations.  Send a proportional amount of seeds to it.
								if neighbours[i].owner == 0 and numberofseedsleft < 10 then
									-- don't bother sending.
								
								elseif neighbours[i].owner == 0 and neighbours[i]:GetNumSeedlings(0) > 0 and numberofseedsleft > 9 + (neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)) then
									-- attack the greys!
									checkedroid:SendSeedlingsToTarget(checkedroid.owner, checkedroid:GetNumSeedlings(checkedroid.owner), neighbours[i])
									numberofseedsleft = 0
								
								elseif neighbours[i].owner == 0 and numberofseedsleft > 9 and (neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)) == 0 then
									-- this is the last we can manage.  Send all 10.
									checkedroid:SendSeedlingsToTarget(checkedroid.owner, 10, neighbours[i])
									numberofseedsleft = numberofseedsleft - 10
								
								elseif neighbours[i].owner == checkedroid.owner then
									checkedroid:SendSeedlingsToTarget(checkedroid.owner, numberperdestination, neighbours[i])
									numberofseedsleft = numberofseedsleft - numberperdestination
								end
							end
						end
					end
				end
			end
			
		
		
		
		
			-- 3.  Attack the weakest nearby asteroid
			
			-- Are we a gather point?  Only gather points are allowed to attack.
			
			if metric[checkedroid.id] == 200 then

				totalenemies = 0
				totalfriendlies = checkedroid:GetNumSeedlings(checkedroid.owner)
				weakestamount = 10000
				weakestroid = checkedroid
				attack = false
				orphan = true
				numberofenemyroids = 0

				
				for i = 0,numberofneighbours do
					
					if neighbours[i].owner == checkedroid.owner and neighbours[i] ~= checkedroid then
						orphan = false
					end
					
					if neighbours[i].owner ~= checkedroid.owner and neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner) > 5 then
						-- found an attack path
						numberofenemyroids = numberofenemyroids + 1
					end
					
					for j = 0,10 do
						if checkedroid.owner ~= j then
							totalenemies = totalenemies + neighbours[i]:GetNumSeedlings(j)
							
							if weakestamount > neighbours[i]:GetNumSeedlings(j) and neighbours[i].owner == j then
								-- the owner of this asteroid has a smaller number of seeds than we've seen before...
								weakestamount = neighbours[i]:GetNumSeedlings(j)
								weakestroid = neighbours[i]
							end
						
						
						end
					end
					
					if neighbours[i] ~= checkedroid and neighbours[i].owner ~= checkedroid.owner then
						if neighbours[i]:GetNumSeedlings(checkedroid.owner) > (neighbours[i]:GetNumSeedlings() - neighbours[i]:GetNumSeedlings(checkedroid.owner)) then
							-- already attacking, and winning.  send reinforcements.
							checkedroid:SendSeedlingsToTarget(checkedroid.owner, checkedroid:GetNumSeedlings(checkedroid.owner), neighbours[i])
						
						end
					end
				end
				
				
				
				-- in the first case, we have more seedlings than all the neighbouring asteroids put together.
				if totalfriendlies > totalenemies + (weakestroid:GetNumTrees() * 10) then
					attack = true
				end
				
				split = false
				
				-- in the second case, we have more than 150 seedlings on this roid, and it's time to move out!
				if totalfriendlies > 150 then
					attack = true
					split = true
				end
				
				if totalfriendlies >= Globals.Asteroids.SpawnCap and orphan == true then
					attack = true
				end
				
				
				if attack == true and checkedroid.owner > 1 and split == false then
					-- ok so we're a gather point, we're ready to attack, and we aren't a player or greys asteroid.
					-- lets move out.
					checkedroid:SendSeedlingsToTarget(checkedroid.owner, totalfriendlies, weakestroid)
				elseif attack == true and checkedroid.owner > 1 and split == true then
				
					for i = 0,numberofneighbours do
						if neighbours[i].owner ~= checkedroid.owner then
							-- attackable path - send proportional amount of seeds.
							checkedroid:SendSeedlingsToTarget(checkedroid.owner, totalfriendlies / numberofenemyroids, neighbours[i])
						end
					end
				end
				
			
				
			end
		
		end
		-- Set asteroid names to whatever their metric is.
		

	
		--checkedroid.Name = metric[checkedroid.ID]
	end

	-- *** END INFECTED AI V2 ***
end


function GravityEngine()

		local sine = math.sin
		local cosine = math.cos
		local pie = math.pi
		local squirt = math.sqrt
		local atantwo = math.atan2
		local GameTime = GetGameTime()
	
		if gravinit == false then
			
			gravinit = true
			
			local Timer = 0
			local CoordX = {}
			local CoordY = {}
			local density = {}
			local roidradius = {}
			local MomentumX = {}
			local MomentumY = {}
			local AccelerationX = {}
			local AccelerationY = {}
			local collision = {}
	
			for i = 0,roidnumber do
				CoordX[i] = GetAsteroid(i).position.x
				CoordY[i] = GetAsteroid(i).position.y
				density[i] = 0.1
				roidradius[i] = GetAsteroid(i).radius
				MomentumX[i] = 0
				MomentumY[i] = 0
				AccelerationX[i] = 0
				AccelerationX[i] = 0
			end
		end
		
		-- START GRAVITY ENGINE
		-- change things below this line at your own peril!!
		-- Rate Limiter - necessary to pause gravity simulation if the game is paused.
		if GameTime > Timer + 0.0 then
			Timer = GameTime
			-- Get values for the the array
			for i = 0, gravroidsthreshold do
				for j = i + 1, gravroidsthreshold do
					-- calculate Fgx and Fgy between i and j, then...
					local Fgx = (G * ((roidradius[i] * roidradius[i]) * pie * density[i]) * ((roidradius[j] * roidradius[j]) * pie * density[j])) / ((CoordX[j] - CoordX[i])^2 + (CoordY[j] - CoordY[i])^2)
					local Fgy = (G * ((roidradius[i] * roidradius[i]) * pie * density[i]) * ((roidradius[j] * roidradius[j]) * pie * density[j])) / ((CoordX[j] - CoordX[i])^2 + (CoordY[j] - CoordY[i])^2)
					-- now we have the force of gravity x and y, as a scalar.  we must find the direction to point in:
					local xdiff = CoordX[j] - CoordX[i]
					local ydiff = CoordY[j] - CoordY[i]
					-- find the length of the vector..
					local vectorlength = squirt(xdiff^2 + ydiff^2)
					-- divide the vectors by the length to normalise
					local NormalisedVectorX = xdiff / vectorlength
					local NormalisedVectorY = ydiff / vectorlength
					-- these normalised vectors are values between 0 and 1 that give us a direction :>
					
					
					
					-- check if there has been a collision
					-- if collision = true then
					
					local comboradius = GetAsteroid(i).radius + GetAsteroid(j).radius
					
					
					
					if ((CoordX[j] - CoordX[i])^2 + (CoordY[j] - CoordY[i])^2) <= comboradius^2 then
						-- a collision has occurred!
						collision[j] = true
						collision[i] = true
						-- ***
						-- first calculate the ratio of overlap to see how far inside this frame brought the asteroid
						
						local overlap = (GetAsteroid(j).radius + GetAsteroid(i).radius) - squirt((CoordX[j] - CoordX[i])^2 + (CoordY[j] - CoordY[i])^2)
						
						local totaldistancemoved = squirt(MomentumX[i]^2 + MomentumY[i]^2) + squirt(MomentumX[j]^2 + MomentumY[j]^2)
						
						local ratioofoverlap = overlap / totaldistancemoved

						-- ***
						-- update the positions of the colliding (and overlapping) roids to the positions from the previous cycle (lazy method)
						
						
						
							CoordX[i] = oldCoordX[i]
							CoordY[i] = oldCoordY[i]
							CoordX[j] = oldCoordX[j]
							CoordY[j] = oldCoordY[j]
							local oldmomentumxi = MomentumX[i]
							local oldmomentumyi = MomentumY[i]
							local oldmomentumxj = MomentumX[j]
							local oldmomentumyj = MomentumY[j]
						
						-- ***
						-- We can calculate how much to _actually_ move forward by multiplying momentum with (1 - ratio of overlap).
						
						MomentumX[i] = MomentumX[i] * (1 - ratioofoverlap)
						MomentumY[i] = MomentumY[i] * (1 - ratioofoverlap)
						MomentumX[j] = MomentumX[j] * (1 - ratioofoverlap)
						MomentumY[j] = MomentumY[j] * (1 - ratioofoverlap)
						
						-- ***
						-- now we can move forward by the specified amount
						CoordX[i] = CoordX[i] + MomentumX[i]
						CoordY[i] = CoordY[i] + MomentumY[i]
						CoordX[j] = CoordX[j] + MomentumX[j]
						CoordY[j] = CoordY[j] + MomentumY[j]
						
						-- now restore the old momentum values to get the correct amount of bounce
						MomentumX[i] = oldmomentumxi
						MomentumY[i] = oldmomentumyi
						MomentumX[j] = oldmomentumxj
						MomentumY[j] = oldmomentumyj
						
						
						
						-- modify momentum for bounce values
						
						--collidedbefore[i] = collidedbefore[i] + 1
						--collidedbefore[j] = collidedbefore[j] + 1
						
						
						
						
						-- first up, what's the total mass of these colliding objects?
						local imass = pie * roidradius[i] * roidradius[i]
						local jmass = pie * roidradius[j] * roidradius[j]
						local totalmass = imass + jmass

						
						
						
						-- change the momentums of both roids for the IDEAL bounce.
					
						
						local dx = MomentumX[i] - MomentumX[j]
						local dy = MomentumY[i] - MomentumY[j]
						local collision_angle = atantwo(dx, dy)
						local magnitude_1 = squirt((MomentumX[i] * MomentumX[i]) + (MomentumY[i] * MomentumY[i]))
						local magnitude_2 = squirt((MomentumX[j] * MomentumX[j]) + (MomentumY[j] * MomentumY[j]))
						local direction_1 = atantwo(MomentumY[i], MomentumX[i])
						local direction_2 = atantwo(MomentumY[j], MomentumX[j])
						local new_xspeed_1 = 1.1 * magnitude_1 * cosine(direction_1 - collision_angle)
						local new_yspeed_1 = 1.1 * magnitude_1 * sine(direction_1 - collision_angle)
						local new_xspeed_2 = 1.1 * magnitude_2 * cosine(direction_2 - collision_angle)
						local new_yspeed_2 = 1.1 * magnitude_2 * sine(direction_2 - collision_angle)
						local final_xspeed_1 = ((imass - jmass) * new_xspeed_1 + (jmass + jmass) * new_xspeed_2) / totalmass
						local final_xspeed_2 = ((imass + imass) * new_xspeed_1 + (jmass - imass) * new_xspeed_2) / totalmass
						local final_yspeed_1 = new_yspeed_1
						local final_yspeed_2 = new_yspeed_2
						MomentumX[i] = cosine(collision_angle) * final_xspeed_1 + cosine(collision_angle + pie / 2) * final_yspeed_1
						MomentumY[i] = sine(collision_angle) * final_xspeed_1 + sine(collision_angle + pie / 2) * final_yspeed_1
						MomentumX[j] = cosine(collision_angle) * final_xspeed_2 + cosine(collision_angle + pie / 2) * final_yspeed_2
						MomentumY[j] = sine(collision_angle) * final_xspeed_2 + sine(collision_angle + pie / 2) * final_yspeed_2

						
						if i < wellonlythreshold then
							MomentumX[i] = 0
							MomentumY[i] = 0
						end
						
						if j < wellonlythreshold then
							MomentumX[j] = 0
							MomentumY[j] = 0
						end
				
						-- ***
						-- now we have the new trajectory.  move forward in this new direction for an amount of time equal to the momentum * ratio of overlap

						local oldmomentumxi = MomentumX[i]
						local oldmomentumyi = MomentumY[i]
						local oldmomentumxj = MomentumX[j]
						local oldmomentumyj = MomentumY[j]
						
						MomentumX[i] = MomentumX[i] * ratioofoverlap
						MomentumY[i] = MomentumY[i] * ratioofoverlap
						MomentumX[j] = MomentumX[j] * ratioofoverlap
						MomentumY[j] = MomentumY[j] * ratioofoverlap


						
						CoordX[i] = CoordX[i] + MomentumX[i]
						CoordY[i] = CoordY[i] + MomentumY[i]
						CoordX[j] = CoordX[j] + MomentumX[j]
						CoordY[j] = CoordY[j] + MomentumY[j]

						-- now restore the old momentum
						MomentumX[i] = oldmomentumxi
						MomentumY[i] = oldmomentumyi
						MomentumX[j] = oldmomentumxj
						MomentumY[j] = oldmomentumyj
						

					
					
						-- ..Now add the appropriate amount of acceleration
					--	AccelerationX[i] = AccelerationX[i] + (NormalisedVectorX * Fgx / ((roidradius[i] * roidradius[i]) * pie) * density[i])
					--	AccelerationY[i] = AccelerationY[i] + (NormalisedVectorY * Fgy / ((roidradius[i] * roidradius[i]) * pie) * density[i])
					--	xdiff = CoordX[i] - CoordX[j]
					--	ydiff = CoordY[i] - CoordY[j]
					--	local NormalisedVectorX = xdiff / vectorlength
					--	local NormalisedVectorY = ydiff / vectorlength
					--	AccelerationX[j] = AccelerationX[j] + (NormalisedVectorX * Fgx / ((roidradius[j] * roidradius[j]) * pie) * density[j])
					--	AccelerationY[j] = AccelerationY[j] + (NormalisedVectorY * Fgy / ((roidradius[j] * roidradius[j]) * pie) * density[j])

					

						
					
					
					else
					
						
						
						
						-- else if there wasn't a collision then
						-- ..add the appropriate amount of acceleration as normal
						AccelerationX[i] = AccelerationX[i] + (NormalisedVectorX * Fgx / ((roidradius[i] * roidradius[i]) * pie) * density[i])
						AccelerationY[i] = AccelerationY[i] + (NormalisedVectorY * Fgy / ((roidradius[i] * roidradius[i]) * pie) * density[i])
						xdiff = CoordX[i] - CoordX[j]
						ydiff = CoordY[i] - CoordY[j]
						local NormalisedVectorX = xdiff / vectorlength
						local NormalisedVectorY = ydiff / vectorlength
						AccelerationX[j] = AccelerationX[j] + (NormalisedVectorX * Fgx / ((roidradius[j] * roidradius[j]) * pie) * density[j])
						AccelerationY[j] = AccelerationY[j] + (NormalisedVectorY * Fgy / ((roidradius[j] * roidradius[j]) * pie) * density[j])
					end
				end
			end
			
			
			for pass = wellonlythreshold,gravroidsthreshold do
				MomentumX[pass] = MomentumX[pass] + AccelerationX[pass]
				MomentumY[pass] = MomentumY[pass] + AccelerationY[pass]
				
				
				

				

				-- national speed limit

				if (MomentumX[pass]^2 + MomentumY[pass]^2) > 10000 then
					MomentumX[pass] = MomentumX[pass] * 0.93
					MomentumY[pass] = MomentumY[pass] * 0.93
				end
				
				if (MomentumX[pass]^2 + MomentumY[pass]^2) > 900 then
					MomentumX[pass] = MomentumX[pass] * 0.98
					MomentumY[pass] = MomentumY[pass] * 0.98
				end
				
				
				if (MomentumX[pass]^2 + MomentumY[pass]^2) > 36 then
					MomentumX[pass] = MomentumX[pass] * 0.999
					MomentumY[pass] = MomentumY[pass] * 0.999
				end
				
				
				
				
				-- MOVE GETASTEROID(PASS) by MomentumX and MomentumY
			
					oldCoordX[pass] = CoordX[pass]
					oldCoordY[pass] = CoordY[pass]
				--if collision[pass] == false then
					CoordX[pass] = CoordX[pass] + MomentumX[pass]
					CoordY[pass] = CoordY[pass] + MomentumY[pass]
				--end
				
				
				
				
				
				GetAsteroid(pass):MoveTo(CoordX[pass], CoordY[pass])
				AccelerationX[pass] = 0
				AccelerationY[pass] = 0
			end
		end
		
		for i = 0,roidnumber do 
			collision[i] = false
		end
		
		-- END GRAVITY ENGINE
end


function ParallaxEngine()
	-- *** PARALAX SCROLLING ENGINE ***
	-- *** FIRST DRAFT - STARFIELD DESIGN ***

	-- calculate which asteroids are visible
	local visible = {}
	local NumberOfVisibleRoids = -1

	for i = 0,numberofasteroids do
		if GetAsteroid(i)~= nil then
			if IsOnScreen(GetAsteroid(i).position.x,GetAsteroid(i).position.y,GetAsteroid(i).radius) == true then
				NumberOfVisibleRoids = NumberOfVisibleRoids + 1
				visible[NumberOfVisibleRoids] = GetAsteroid(i)
			end
		end
	end
	
	for layer = 1,numberoflayers do	
		local alpha = 1 - ((1 / GetCameraScale()) * threshold[layer])
		if alpha > stoprenderingbelow then
			local istart = ((layer - 1) * starsinlayer) + 1				
			local iend = layer * starsinlayer
			
			for i = istart, iend do
				-- far background
				linex1[i] = (GetCameraX() / zdepth[layer]) + linex1mod[i]
				liney1[i] = (GetCameraY() / zdepth[layer]) + liney1mod[i]
				
				if IsOnScreen(linex1[i],liney1[i],starsize) == true then
					local draw = true
					
					for j = 0,NumberOfVisibleRoids do
						if draw == true then
							
							local singleDXcheck = linex1[i] - visible[j].position.x
							
							-- distance - may be pos or neg

							if singleDXcheck > -visible[j].radius and singleDXcheck < visible[j].radius then
								-- there's a 1 dimensional overlap
								local singleDYcheck = liney1[i] - visible[j].position.y
								if singleDYcheck > -visible[j].radius and singleDYcheck < visible[j].radius then
									-- there's a bounding box overlap.  check it in proper 2D now.
									if (linex1[i] - visible[j].position.x)^2 + (liney1[i] - visible[j].position.y)^2 < visible[j].radius^2 then
										-- Obscured.  Don't render
										draw = false
										break
									end
								end
							end
							

						end
					end
					
					if draw == true then
						DrawSprite(0, linex1[i],liney1[i], red[layer],green[layer],blue[layer],alpha, starsize)
					end
				end
			end
		end
	end
	-- *** END PARALAX SCROLLING ENGINE ***
end


function LevelSetup()

	Game = luanet.import_type("Eufloria.Game") -- Import the game type to get access to the game instance and therefore the backdrop colour.
	Colour=Game.Instance.BackdropColour -- Copy the existing backdrop colour - we're only doing this to get hold of a colour object we can change.
	Colour.R = 0 -- insert your own colour.  allowed values 0-1
	Colour.G = 0
	Colour.B = 0
	Game.Instance.BackdropColour = Colour -- re-assign the backdrop colour to your own value.
	Game.Instance.TargetBackdropColour = Colour -- Set the target backdrop colour or the backdrop will fade right back to where it was. If you don't do this you'll get a flash of your desired colour - could also be useful.

	-- ** None of these are strictly necessary for Gravity... change as you like. **
	SetBackdropColour(0,0,0)
	SetCameraZoom(1)
	Globals.Agents.MaxSpeed=1000
	Globals.Agents.MinSpeed=450

	Globals.Asteroids.CoreHealthPower=1
    Globals.Asteroids.MinSendDistance=60000
    Globals.Asteroids.MaxSendDistance=60000
    Globals.Asteroids.SendPowerRule=1.4
	Globals.Asteroids.SpawnCap=100
	Globals.Asteroids.SeedlingCap=1000
	Globals.Asteroids.MinCoreHealth=250
	Globals.Asteroids.MaxCoreHealth=650
	Globals.G.Asteroids=(0)

	Globals.AI.GraceTimer=(9999999)


	Globals.G.EnemyFactionsMin=(0)
	Globals.G.EnemyFactionsMax=(0)
	Globals.G.MinAsteroidSeparation=100
	Globals.G.MaxAsteroidNeighbourDist=60000
	Globals.G.GreysProbability=0

	Globals.Structures.FlowerProbability=(0)
	
	SetVignetteAlpha(0)
	
	
	-- initialise screen wrap artwork
	-- left line
	Line1x1 = -18000
	Line1y1 = -18000
	Line1x2 = -18000
	Line1y2 = 18000
	
	-- bottom line
	Line2x1 = -18000
	Line2y1 = -18000
	Line2x2 = 18000
	Line2y2 = -18000
	
	-- right line
	Line3x1 = 18000
	Line3y1 = -18000
	Line3x2 = 18000
	Line3y2 = 18000
	
	-- top line
	Line4x1 = -18000
	Line4y1 = 18000
	Line4x2 = 18000
	Line4y2 = 18000
	
	b3 = 0.2
	
	
	
	-- initialise modules
	ParallaxInit()
	GravityInit()
	AIInit()
	monitor = GetGameTime() + 15
	frames = 0
	
	SetCameraPositionToAsteroidID(0)
	endtime = nil
	gamewon = false
	spawntimer = 0
	seedcounter = 0
	
end


function LevelDraw()

	ParallaxEngine()
	

	
	local b1 = math.sin(GetGameTime())
	local b2 = math.cos(GetGameTime())
	
	
	DrawLine(Line1x1,Line1y1,Line1x2,Line1y2,b3,b1,0,1,b3,0,b2,1,120)
	DrawLine(Line2x1,Line2y1,Line2x2,Line2y2,b3,b1,0,1,b3,0,b2,1,120)
	DrawLine(Line3x1,Line3y1,Line3x2,Line3y2,b3,0,b2,1,b3,b1,0,1,120)
	DrawLine(Line4x1,Line4y1,Line4x2,Line4y2,b3,0,b2,1,b3,b1,0,1,120)
	
end


function LevelLogic()
	
	-- Zoom the camera
	SetCameraZoom(3.5)
	
	
	-- Remove the player's asteroid, but tell the player seedlings to plant.
	GetAsteroid(0).owner = 0
	GetAsteroid(0):PlantDysonTree(1)
	GetAsteroid(0):PlantDysonTree(1)
	GetAsteroid(0):PlantDysonTree(1)
	
	
	-- *** Set the send distances you want for each asteroid here.
	
	-- *** I know you normally do it in Level Setup but in gravityland we do it here.
	GetAsteroid(0).SendDistance = 8000
	GetAsteroid(1).SendDistance = 500 + roidradius[1] * 10
	
	for ii = 2,roidnumber do
		GetAsteroid(ii).SendDistance = 0
		GetAsteroid(ii).radius = 0
	end
	
	
	for i = 0,roidnumber do
	
		
	
	end
	
	-- *** End setting of send distances
	
	addonce = nil
	
	while GameRunning() do

		-- *** YOUR LOOPED COMMANDS GO HERE *** --

		-- fade in the roids to avoid them spawning on top of each other, and because it looks freaking awesome!
		
		for i = 2, roidnumber do
			if GetAsteroid(i).radius < roidradius[i] and GetGameTime() > i / 5 then
				GetAsteroid(i):SetRadius(GetAsteroid(i).radius + 10)
			end
			
			if GetAsteroid(i).SendDistance < (500 + (roidradius[i] * 10)) then
				GetAsteroid(i).SendDistance = GetAsteroid(i).SendDistance + 10
			end
		end
	
		-- shooting star :>
		linex1mod[670] = 18000 * math.sin(30 + GetGameTime() / 11)
		liney1mod[670] = 18000 * math.sin(GetGameTime() / 14)

	
		-- screenwrapping
		for wrap = 0,roidnumber do
			if CoordX[wrap] > 18000 then
				CoordX[wrap] = -18000
			end

			if CoordY[wrap] > 18000 then
				CoordY[wrap] = -18000
			end

			if CoordX[wrap] < -18000 then
				CoordX[wrap] = 18000
			end

			if CoordY[wrap] < -18000 then
				CoordY[wrap] = 18000
			end
		end

		
		
		if GetEmpire(2):GetNumOwnedAsteroids() == 0 and GetEmpire(9):GetNumOwnedAsteroids() == 0 and endtime == nil and GetGameTime() > 40 then
			MessageBox("Victory!")
			gamewon = true
			endtime = GetGameTime() + 10
		end
		
		if gamewon == true and starsize < 10000 then
			starsize = starsize * 1.015
		end
		
		if gamewon == true then
			if GetGameTime() > endtime then
				Quit(true)
			end
		end
		
		if GetEmpire(1):GetNumOwnedAsteroids() == 0 and GetGameTime() > 15 then
			Quit(false)
		end

		
		if GetGameTime() > 20 and addonce == nil then
			if spawntimer < GetGameTime() then
				spawntimer = GetGameTime() + 0.1
				
				if seedcounter < 31 then
					seedcounter = seedcounter + 1
					if GetEmpire(1).NumSeedlings < 30 then
						GetAsteroid(0):AddSeedlings(1,1,0.8,0.3,0.7)
					end
					GetAsteroid(1):AddSeedlings(1, 2, 0.6, 0.4, 1)
					GetAsteroid(2):AddSeedlings(1, 9, 0.6, 0.4, 1)
					GetAsteroid(3):AddSeedlings(1, 2, 0.6, 0.4, 1)
					GetAsteroid(4):AddSeedlings(1, 9, 0.6, 0.4, 1)
					GetAsteroid(5):AddSeedlings(1, 2, 0.6, 0.4, 1)
					GetAsteroid(6):AddSeedlings(1, 9, 0.6, 0.4, 1)
				else
					addonce = false
				end
			end
		end
		
		
		-- *** YOUR LOOPED COMMANDS END HERE *** ---

		
--[[		if monitor < GetGameTime() then
			before = os.clock()
			GravityEngine()
			aftergrav = os.clock() - before
			InfectedAIEngine()
			afterai = os.clock() - aftergrav - before
			MessageBox("Gravity: " .. aftergrav .. "                               AI: " .. afterai .. ".                                           " .. (frames / 15) .. " frames per second.")
			frames = 0
			monitor = monitor + 15
		else
			GravityEngine()
			InfectedAIEngine()
			frames = frames + 1
		end--]]
		
			GravityEngine()
			InfectedAIEngine()
		
		coroutine.yield()
	end


	
end