function LevelDraw()
end

function LevelSetup()

NumRoids = 0

	-- Set Global Values
	Globals.G.Asteroids=(0)
	Globals.G.EnemyFactionsMin=(1)
	Globals.G.EnemyFactionsMax=(1)
        Globals.G.MinAsteroidSeparation=(500)
        Globals.G.MaxAsteroidNeighbourDist=(8000)
        Globals.Structures.SpawnTime1 = (1)
        Globals.Structures.SpawnTime2 = (1)
        Globals.Structures.SpawnTime3 = (1)
        Globals.Structures.SpawnTime4 = (1)
        Globals.G.GreysProbability = (0)
        Globals.Agents.MinSpeed = (110)
        Globals.Agents.MaxSpeed = (600)
        Globals.Agents.TurnRate = (1)

        for t=0,1080 do
        xPos = 600 * math.rad(t)*(math.cos(math.rad(t)))
        xError = math.random(-800,800)

        yPos = 600 * math.rad(t)*(math.sin(math.rad(t)))
        yError = math.random(-800,800)
        
        MakeAsteroidCheck = math.random(1,1080)

              if MakeAsteroidCheck < 21 then
              Roid = AddAsteroid((xPos),(yPos))
              NumRoids = NumRoids + 1
              --Roid.Moveable = false
              Size = math.random(150,500)
              Roid:SetRadius(Size)
              Roid.SendDistance = 8000
              end
        
        
        end

home = GetRandomRangeEmptyAsteroid(10,(NumRoids-1))
home.Owner = 1
home:AddSeedlings(10)
b = home:AddDysonTree()
b:LevelUp()
b:LevelUp()
b:LevelUp()

a = GetRandomRangeEmptyAsteroid(0,6)
a.Owner = 2
a:AddSeedlings(10)
c = a:AddDysonTree()
c:LevelUp()
c:LevelUp()
c:LevelUp()

	
end



function LevelLogic()

SetCameraPositionToAsteroidID(home.ID)

for i=0,(NumRoids-1) do
   Roid = GetAsteroid((i))
   Roid.SendDistance = 50
end    

Pause()
MessageBox("The sun is our life source.")
WaitDialog()
Unpause()

Pause()
MessageBox(" Without it we do not function, we cannot function.")
WaitDialog()
Unpause()

Pause()
MessageBox("The dark ones have taken root in this cluster, seek them out and destroy them.")
WaitDialog()
Unpause()
    
Pause()
MessageBox("But beware young seedling, they do not share our affinity to the light.")
WaitDialog()
Unpause()

      while GameRunning() do

          -- Time the game has been running
          Timer = GetGameTime()
      
          -- Simulate the Sun 
          rcolour = 127.5 + (127.5*(math.cos(math.rad(Timer*6))))
          gcolour = 127.5 + (127.5*(math.cos(math.rad(Timer*6))))
          SetBackdropColour(rcolour,gcolour,0)
                                          coroutine.yield()
      

          -- Determines Send Distance
          for i=0,(NumRoids-1) do
             Roid = GetAsteroid((i))
             nSlots = Roid:FreeSlots()
             nTrees = Roid:GetNumTrees() 
             tTrees = nTrees + nSlots
             Roid.SendDistance = (nTrees/tTrees)*(3000 + (2999 *(math.cos(math.rad(Timer*6)))))

                if GetAI(2):OwnsAsteroidID(Roid.ID) == true then
                 Roid.SendDistance = 6000
                end
          end

       -- Determines Functionality
           if (math.cos(math.rad(Timer*6))) < 0 then 
              SetDysonTreeButtonAvailable(false)
           end
       

           if (math.cos(math.rad(Timer*6))) < 0 then 
              SetDefenseTreeButtonAvailable(false)
           end
       
           if (math.cos(math.rad(Timer*6))) > 0 then 
              SetDysonTreeButtonAvailable(true)
           end
       
           if (math.cos(math.rad(Timer*6))) > 0 then 
              SetDefenseTreeButtonAvailable(true)
           end

        -- Check for end conditions
           if GetEmpire(1):GetNumOwnedAsteroids() == 0 then
              Pause()
              MessageBox("You have been defeated")
              WaitDialog()
              Unpause()
              
              Quit(false)
           end

           if GetAI(2):GetNumOwnedAsteroids() == 0 then
              Pause()
              MessageBox("You are victorious!")
              WaitDialog()
              Unpause()

              Quit(true)
           end            

      end

end